#==========================================================
# Mainlib --
#
#    main procedures that build the main GUI
#
#==========================================================
#
namespace eval Mainlib {

    variable _base64
    variable Win
    variable boolean
    variable img
    variable state_fields

    set state_fields [list autoload viewsystem viewpgaccess savepasswords]
    
    array set boolean {t yes f no true yes false no T yes F no}
    
    set _base64(si_grid) {
    R0lGODlhDwAOAPcAAAAAAAAA/4QAAISEhKX/KcbGxv//////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    /////////////////////////////////yH5BAEAAAQALAAAAAAPAA4AAAhbAAkIHDgQAACC
    CAUaHDDgYEICCxk2TBiRoYECBhxCBBAggMUCAgRkVNjxowGRJ0cCMIlRQMuREA1clNlSJMaD
    K2nOnHlToU6eGTXmBGqQos6iD3MifahQY8KAAAA7
    }
    set _base64(si_drive4) {
    R0lGODlhDwAOAPcAAAAAAISEhMbGxv8pzv//AP//////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    /////////////////////////////////yH5BAEAAAMALAAAAAAPAA4AAAhhAAcIHACgoEEA
    AwcWFECAIYGHBRU2nOjQIUIAFCc+3EhgYUaNGw0yHMkRYsGOGEuiXBnSZEqUKQXILCAz5MmT
    AgrQbHjzZUeXIQk+lJmzJkSFGHPuFBAx4YAAAAJAbSowIAA7
    }
    set _base64(si_drive3) {
    R0lGODlhEAAJAPcAAAAAAAAInACEAADOAHNzc5SUlJycnLW1tcbGxtbW1t7e3v//////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    /////////////////////////////////yH5BAEAAAEALAAAAAAQAAkAAAhKAAMEIECwoMGC
    AgkcWMiw4UICAAgsmEix4kQDEAkkQMCxI4IDAwQcKJBRwQGPHxuSjKjg4MGRGRNYtAgzosub
    AAQC2MmzJ0+BAQEAOw==
    }
    
    set _base64(si_sql) {R0lGODlhEAAWAPcAAAAAAAgICBgYGDEhMTExMTk5OUJCQkoY/0pKSlJSUlpa
    WmNjY2tra3Nzc3t7e4SEhIyMjIyU3pSUlJycnKWlpa2trbW1tb29vcbGxs7O
    zt7e3ufn5+/v7/f39///////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    /////////////////////yH5BAEAAAcALAAAAAAQABYAAAiMAA8IHEiwoMGD
    CAEoXAjgoEIMESBGmKiQIICIGCVKbHjgIsSPE0NS7AhSo8gIDR9mPIkyZUuW
    L12GvNiSJsqONDHo9KBzpkuFET3wjAhUJkWKQEd2nKgTA0+JNwcCdToUQ0WD
    DwA8yHoVodeBVq+KLTjAosCUBsd2XOtwLQAMbKU+FBgAg4ADAvLeDQgAOw==}
    
    
    set _base64(online:rx) {R0lGODlhEAAPAPcAAAAAAAD//yEA1oSEhMbGxv8ICP//////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    /////////////////////yH5BAEAAAIALAAAAAAQAA8AAAhlAAUIHChggMGD
    AwgSHACgoUMCABQKZBjAwMOIExEatNgQ4kSHFy9+NBCgZACIIgsCIGkS4kGP
    Kk2WhEigJkyKMlGC/KiRpkECDAvaHApAY0SGIJM6LGhg6M+gCzUixEhQ6VKF
    AQEAOw==}

	set img(Tables) [image create photo -data $::Mainlib::_base64(si_grid)]
	set img(Queries) ::icon::misc-16
	set img(Views) ::icon::thumbnail-16
	set img(Sequences) ::icon::queue-16
	set img(Functions) ::icon::completion-16
	set img(Reports) ::icon::txt-16
	set img(Graphs) ::icon::editcut-16
	set img(Forms) ::icon::widget_doc-16
	set img(Images) ::icon::kpresenter-16
	set img(Scripts) ::icon::shellscript-16
	set img(Usergroups) ::icon::people-16
	set img(Diagrams) ::icon::desktop_flat-16
	set img(Types) ::icon::blockdevice-16
	set img(Domains) ::icon::kcmprocessor-16
	set img(Triggers) ::icon::package_games1-16
	set img(Aggregates) ::icon::view_sidetree-16
	set img(Casts) ::icon::remote-16
	set img(Conversions) ::icon::earth-16
	set img(Indexes) ::icon::info-16
	set img(Languages) ::icon::contents2-16
	set img(Operators) ::icon::kteatime-16
	set img(Operatorclasses) ::icon::source_java-16
	set img(Rules) ::icon::penguin-16

}; # end namespace Mainlib

#----------------------------------------------------------
# ::Mainlib::tab_click --
#
#    This is used to invoke a tab. This was changed for the
#    the interface to instead select a node in the tree
#
# Arguments:
#    tabname_    The name of the tab
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::tab_click {tabname_} {

    global PgAcVar CurrentDB
    variable Win

    set deslist $PgAcVar(tablist)

    #set w .pgaw:Main.tab$tabname
    if {$CurrentDB==""} return;
    set curtab $tabname_
    #if {$PgAcVar(activetab)==$curtab} return;
    set PgAcVar(activetab) $curtab

    # Tabs where button Design is enabled
    if {[lsearch $deslist $PgAcVar(activetab)]!=-1} {
        if {[string match "" $PgAcVar(currentdb,host)]} {
            #set PgAcVar(currentdb,host) sockets
            set PgAcVar(currentdb,host) ""
        }


        set node ${PgAcVar(currentdb,host)}-${PgAcVar(currentdb,dbname)}-${curtab}
        if {[$Win(tree) exists $node]} {
            $Win(tree) selection set $node
                  #.pgaw:Main.btndesign configure -state normal
            set PgAcVar(activetab) $tabname_
        }
    }
           	#.pgaw:Main.lb delete 0 end
	          #cmd_$curtab

    return
}; # end proc ::Mainlib::tab_click


#----------------------------------------------------------
# ::Mainlib::cmd_Delete --
#
#    Handles the Delete button when clicked
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Delete {} {
    global PgAcVar CurrentDB

    if {$CurrentDB==""} return;
    set objtodelete [get_dwlb_Selection]
    if {$objtodelete==""} {
        showError [intlmsg "Please select an object first!"]
        return;
    }

    if {[lsearch $PgAcVar(tablist) $PgAcVar(activetab)] == -1} {
        return
    }

    set delmsg [format [intlmsg "You are going to delete\n\n %s \n\nProceed?"] $objtodelete]

    if {[tk_messageBox \
             -title [intlmsg "FINAL WARNING"] \
             -parent . \
             -message $delmsg \
             -type yesno \
             -default no]=="no"} { return }


    switch -- $PgAcVar(activetab) {
		Tables {
			sql_exec noquiet "DROP TABLE [::Database::quoteObject $objtodelete]"
			sql_exec quiet "DELETE FROM pga_layout WHERE tablename='$objtodelete'"
			cmd_Tables
		}
		Diagrams {
			sql_exec quiet "DELETE FROM pga_diagrams WHERE diagramname='$objtodelete'"
			cmd_Diagrams
		}
		Views {
			sql_exec noquiet "DROP VIEW [::Database::quoteObject $objtodelete]"
			sql_exec quiet "DELETE FROM pga_layout WHERE tablename='$objtodelete'"
			cmd_Views
		}
		Queries {
			sql_exec quiet "DELETE FROM pga_queries WHERE queryname='$objtodelete'"
			sql_exec quiet "DELETE FROM pga_layout WHERE tablename='$objtodelete'"
			cmd_Queries
		}
		Scripts {
			sql_exec quiet "DELETE FROM pga_scripts WHERE scriptname='$objtodelete'"
			cmd_Scripts
		}
		Forms {
			sql_exec quiet "DELETE FROM pga_forms WHERE formname='$objtodelete'"
			cmd_Forms
		}
		Images {
			sql_exec quiet "DELETE FROM pga_images WHERE imagename='$objtodelete'"
			cmd_Images
		}
		Sequences {
			sql_exec quiet "DROP SEQUENCE [::Database::quoteObject $objtodelete]"
			cmd_Sequences
		}
		Functions {
			delete_function $objtodelete
			cmd_Functions
		}
		Reports {
			sql_exec noquiet "DELETE FROM pga_reports WHERE reportname='$objtodelete'"
			cmd_Reports
		}
		Graphs {
			sql_exec noquiet "DELETE FROM pga_graphs WHERE graphname='$objtodelete'"
			cmd_Graphs
		}
		Usergroups {
			sql_exec noquiet "DROP USER \"$objtodelete\""
			cmd_Usergroups
		}
		Types {
			sql_exec noquiet "DROP TYPE \"$objtodelete\""
			cmd_Types
		}
		Domains {
			sql_exec noquiet "DROP DOMAIN \"$objtodelete\""
			cmd_Domains
		}
		Triggers {
            set trig [::Database::quoteObject [lindex [split $objtodelete .] end]]
            set tbl [::Database::quoteObject [join [lrange [split $objtodelete .] 0 end-1] .]]
			sql_exec noquiet "DROP TRIGGER $trig ON $tbl"
			cmd_Triggers
		}
		Indexes {
            # need to check if we have three parts, then we
            # have a schema at the beginning, then table,
            # then index name -- otherwise, we just have
            # table name and index name (2 parts)
            set idx ""
            if {[llength [split $objtodelete .]]==3} {
                set idx [::Database::quoteObject [lindex [split $objtodelete .] 0]]
                append idx "." [::Database::quoteObject [lindex [split $objtodelete .] end]]
            } else {
                set idx [::Database::quoteObject [lindex [split $objtodelete .] end]]
            }
			sql_exec noquiet "DROP INDEX $idx"
			cmd_Indexes
		}
		Rules {
            # need to check if we have three parts, then we
            # have a schema at the beginning, then table,
            # then index name -- otherwise, we just have
            # table name and index name (2 parts)
            set rul ""
            set tbl ""
            if {[llength [split $objtodelete .]]==3} {
                set tbl [::Database::quoteObject [lindex [split $objtodelete .] 0]]
                append tbl "." [::Database::quoteObject [lindex [split $objtodelete .] 1]]
                set rul [::Database::quoteObject [lindex [split $objtodelete .] 2]]
            } else {
                set tbl [::Database::quoteObject [lindex [split $objtodelete .] 0]]
                set rul [::Database::quoteObject [lindex [split $objtodelete .] 1]]
            }
			sql_exec noquiet "DROP RULE $rul ON $tbl"
			cmd_Rules
		}
		Languages {
			sql_exec noquiet "DROP LANGUAGE \"$objtodelete\""
			cmd_Languages
		}
		Casts {
			sql_exec noquiet "DROP CAST \"$objtodelete\""
			cmd_Casts
		}
		Operatorclasses {
			sql_exec noquiet "DROP OPERATOR CLASS \"$objtodelete\""
			cmd_Operatorclasses
		}
		Operators {
			sql_exec noquiet "DROP OPERATOR \"$objtodelete\""
			cmd_Operators
		}
		Aggregates {
			sql_exec noquiet "DROP AGGREGATE \"$objtodelete\""
			cmd_Aggregates
		}
		Conversions {
			sql_exec noquiet "DROP CONVERSION \"$objtodelete\""
			cmd_Conversions
		}
    }; # end switch
}

#------------------------------------------------------------
# ::Mainlib::cmd_Design --
#
#    Handles the Design tab when click
#
# Arguments:
#    none
#
# Results:
#    none returned
#------------------------------------------------------------
#
proc ::Mainlib::cmd_Design {} {
    global PgAcVar CurrentDB
    variable Win

    #if {$CurrentDB==""} return;
    #if {[$Win(mclist) curselection]==""} return;
    set objname [get_dwlb_Selection]
    #set objname [$Win(mclist) get [$Win(mclist) curselection]]
    set tablename $objname

    if {$objname==""} {
        showError [intlmsg "Please select an object first!"]
        return;
    }

    $PgAcVar(activetab)::design $objname

}

#----------------------------------------------------------
# ::Mainlib::cmd_Forms --
#
#     Handles when the Forms section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Forms {} {

    global CurrentDB
    variable Win

    set sql "
        SELECT formname
          FROM Pga_forms
      ORDER BY formname"

    setCursor CLOCK

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns [list 0 [intlmsg Name] left]

    catch {
	wpg_select $CurrentDB "$sql" rec {
		$Win(mclist) insert end [list $rec(formname)]
	}
    }

    setCursor DEFAULT
    
    return
}


#----------------------------------------------------------
# ::Mainlib::cmd_Functions --
#
#     Handles when the Functions section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Functions {} {

    global PgAcVar CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(pgversion,$id)]} {
        set Connections::Conn(pgversion,$id) \
            [::Database::getPgVersion $CurrentDB]
    }

    if {[string match "" $VER]} {
        showError [intlmsg "Could not find PG Version of the database"]
        return
    }

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    setCursor CLOCK

    set sql [::Database::getFunctionsList $CurrentDB $pg 1 1]

    set cols [list]

    if {$VER>7.3} {
        lappend cols 0 [intlmsg Schema]
    }

    lappend cols 0 [intlmsg Name] left 0 [intlmsg Returns] left 0 [intlmsg Owner] left 0 [intlmsg Language] left

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) delete 0 end

    catch {
        if {$VER>7.3} {
            wpg_select $CurrentDB "$sql" rec {
                $Win(mclist) insert end [list $rec(nspname) $rec(proname) [Database::getPgType $rec(prorettype)] $rec(usename) $rec(lanname)]
            }
        } else {
            wpg_select $CurrentDB "$sql" rec {
                $Win(mclist) insert end [list $rec(proname) [Database::getPgType $rec(prorettype)] $rec(usename) $rec(lanname)]
            }
        }
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Functions



#	set PgAcVar(currentdb,host) $PgAcVar(opendb,host)
#	set PgAcVar(currentdb,pgport) $PgAcVar(opendb,pgport)
#	set PgAcVar(currentdb,dbname) $PgAcVar(opendb,dbname)
#	set PgAcVar(currentdb,username) $PgAcVar(opendb,username)
#	set PgAcVar(currentdb,password) $PgAcVar(opendb,password)
#	set PgAcVar(statusline,dbname) $PgAcVar(currentdb,dbname)


#----------------------------------------------------------
# ::Mainlib::cmd_Dump --
#
#     Handles the db dump function
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Dump {type} {

    global PgAcVar CurrentDB
	set host $PgAcVar(currentdb,host)
	if {$host == ""} {
		showError [intlmsg {No database selected}]
		return
	}
	set dbname $PgAcVar(currentdb,dbname)
	if {$dbname == ""} {
		showError [intlmsg {No database selected}]
		return
	}
	set pgport $PgAcVar(currentdb,pgport)
	set username $PgAcVar(currentdb,username)
	set password $PgAcVar(currentdb,password)

	if {$host == "sockets"} {
		set host "localhost"
	}

	switch -- $type {
		"text" {
			set defaultextension ".sql"
			set initialdir "~"
			set initialfile "dump.sql"
			set title [intlmsg {Dump database (text)}]
		}
		"binary" {
			set defaultextension ".bsql"
			set initialdir "~"
			set initialfile "dump.bsql"
			set title [intlmsg {Dump database (binary)}]
		}
	}

	set FileName [tk_getSaveFile \
		-defaultextension $defaultextension \
		-initialdir $initialdir \
		-initialfile $initialfile \
		-title  $title \
		-parent ".pgaw:Main" \
	]

    if {$FileName != ""} {

        # lets build the connection listing so we can ignore params not given
        set connlist "/usr/bin/pg_dump"
        lappend connlist "-f" $FileName
        if {$host!=""} {lappend connlist "-h" $host}
        if {$pgport!=""} {lappend connlist "-p" $pgport}
        if {$username!=""} {lappend connlist "-U" $username}

        switch -- $type {
            "text" {
                lappend connlist "-i" $dbname
            }
            "binary" {
                lappend connlist "-i" "-b" "-Fc" $dbname
            }
        }

        if {[catch {eval exec [split $connlist]}]} {
            showError [intlmsg "Dump failed, possible bad connection parameters.  If a password is required, you will have to dump from the command line."]
        }

    } else {
        showError [intlmsg "You must supply a file name for the dump."]
    }

    return

}; # end proc ::Mainlib::cmd_Dump

proc ::Mainlib::cmd_New {} {
    global PgAcVar CurrentDB

    if {$CurrentDB==""} return;

    if {[catch {$PgAcVar(activetab)::new} err]} {
        showError [intlmsg "Can not create new \"$PgAcVar(activetab)\": object not supported"]

    }

    return
}


#----------------------------------------------------------
# ::Mainlib::cmd_Introspect --
#
# Arguments:
#    asquery_   1 to open up in query window instead of main
#
# Results:
#    wrapper around introspecting an object to get at its
#    SQL representation
#
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Introspect {{asquery_ 0}} {

    global PgAcVar CurrentDB

    variable Win

    # make sure we should be introspecting
    if {[string length $Win(sqlintro)]>0} {
        if {!$PgAcVar(pref,showintropane)} {
            if {[winfo exists $Win(sqlintro)]} {
                $Win(sqlintro) delete 1.0 end
            }
            return
        }
    } else {
        return
    }

    set sql [intlmsg "-- NO SQL AVAILABLE --"]

    if {$CurrentDB==""} return;

    set objname [get_dwlb_Selection]

    if {$objname==""} return;

    catch {set sql [$PgAcVar(activetab)::introspect $objname $CurrentDB]}

    if {$asquery_} {
        set qname [format [intlmsg "A Query to re-create '%s'"] $objname]
        set PgAcVar(query,sqlcmd) $sql
        set PgAcVar(query,comments) [intlmsg "You can run this query to re-create the object you selected."]
        ::Queries::design $qname 0
    } else {
        $Win(sqlintro) delete 1.0 end
        $Win(sqlintro) insert end $sql
        ::Syntax::highlight $Win(sqlintro) sql
    }

    return

}; # end proc ::Mainlib::cmd_Introspect


#----------------------------------------------------------
# ::Mainlib::cmd_Open --
#
# Arguments:
#    none
#
# Results:
#    wrapper around opening up the object/action
#
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Open {} {
    global PgAcVar CurrentDB

    variable Win

    if {$CurrentDB==""} return;

    set objname [get_dwlb_Selection]
    if {$objname==""} {
        showError [intlmsg "Please select an object first!"]
        return;
    }

    $PgAcVar(activetab)::open $objname

    return
}



#----------------------------------------------------------
# ::Mainlib::cmd_Queries --
#
#     Handles when the Queries section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Queries {} {

    global CurrentDB
    variable Win

    set sql "
      SELECT queryname, querytype, querytables,
             CASE WHEN char_length(querycomments) > 50 THEN
                       substr(querycomments,0,50) || '...'
             ELSE querycomments END AS querycomments
        FROM pga_queries
    ORDER BY queryname"

    set cols [list 0 [intlmsg Name] left 0 [intlmsg Type] left]
    lappend cols 0 [intlmsg Tables] left 0 [intlmsg Comments] left

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) delete 0 end

    catch {
        wpg_select $CurrentDB "$sql" r {
            $Win(mclist) insert end \
            [list $r(queryname) $r(querytype) $r(querytables) $r(querycomments) 0 50]
        }
    }

    return
}; # end proc ::Mainlib::cmd_Queries


#----------------------------------------------------------
# ::Mainlib::cmd_Rename --
#
#     Handles when the Rename section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Rename {} {

    global PgAcVar CurrentDB

    if { $CurrentDB == "" } {
        return
    }

    if { [lsearch {Tables Queries Views Functions Sequences Reports Graphs Forms Images Scripts Diagrams} $PgAcVar(activetab)] == -1 } {
        return
    }

    set temp [get_dwlb_Selection]

    if { $temp == "" } {
        showError [intlmsg "Please select an object first!"]
        return
    }

    set PgAcVar(Old_Object_Name) [::Database::quoteObject $temp]
    set PgAcVar(New_Object_Name) ""

    Window show .pgaw:RenameObject
    wm transient .pgaw:RenameObject

    return

}; # end proc ::Mainlib::cmd_Rename


#----------------------------------------------------------
# ::Mainlib::cmd_Copy --
#
#   Allows for copying certain items between any current
#   database connection open in the main window.  Note that
#   it is impossible to copy objects from newer versions of
#   PostgreSQL to older versions if they were not supported
#   fully in the older versions.
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Copy {} {

    global PgAcVar
    global CurrentDB
    variable Win

    if {$CurrentDB==""} return;

    if {[lsearch {Queries Reports Graphs Forms Images Scripts Diagrams Functions Tables Sequences Views Triggers Domains Indexes Rules Types Aggregates Usergroups Languages Casts Conversions} $PgAcVar(activetab)]==-1} {
        showError [intlmsg "You can't copy $PgAcVar(activetab) yet."]
        return
    }

    set temp [get_dwlb_Selection]
    if {$temp==""} {
        showError [intlmsg "Please select an object first!"]
        return
    }

    set PgAcVar(Old_Object_Name) $temp
    set PgAcVar(New_Object_Name) [get_dwlb_Selection 1]

    set PgAcVar(Connections_List) [list]
    foreach cluster [$Win(tree) nodes root] {
        foreach db [$Win(tree) nodes $cluster] {
            set con [$Win(tree) itemcget $cluster -text]
            append con ":" [$Win(tree) itemcget $db -text]
            lappend PgAcVar(Connections_List) $con
        }
    }

    if {![info exists PgAcVar(Copy_To_Connection)]} {
        set PgAcVar(Copy_To_Connection) [lindex $PgAcVar(Connections_List) 0]
    }

    Window show .pgaw:CopyObject
    wm transient .pgaw:CopyObject .pgaw:Main

}; # end proc ::Mainlib::cmd_Copy


#----------------------------------------------------------
# ::Mainlib::cmd_Reports --
#
#     Handles when the Reports section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Reports {} {

    global CurrentDB
    variable Win

    set sql "
        SELECT reportname,reportsource
          FROM Pga_reports
      ORDER BY reportname"

    setCursor CLOCK

    set cols [list 0 [intlmsg Name] left 0 [intlmsg Source] left]

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) delete 0 end

    catch {
	wpg_select $CurrentDB "$sql" rec {
	    $Win(mclist) insert end [list $rec(reportname) $rec(reportsource)]
	}
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Reports


#----------------------------------------------------------
# ::Mainlib::cmd_Graphs --
#
#     Handles when the Graphs section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Graphs {} {

    global CurrentDB
    variable Win

    set sql "
        SELECT graphname,graphsource
          FROM Pga_graphs
      ORDER BY graphname"

    setCursor CLOCK

    set cols [list 0 [intlmsg Name] left 0 [intlmsg Source] left]

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) delete 0 end

    catch {
	wpg_select $CurrentDB "$sql" rec {
	    $Win(mclist) insert end [list $rec(graphname) $rec(graphsource)]
	}
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Graphs


#----------------------------------------------------------
# ::Mainlib::cmd_Usergroups --
#
#     Handles when the Usergroups section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Usergroups {} {

    global CurrentDB
    variable Win
    variable boolean

    set cols [list 0 [intlmsg Name] left 0 [intlmsg Id] left 0 [intlmsg "Create DB?"] left 0 [intlmsg "Super?"] left]

    set sql "
        SELECT usename,usesysid,usecreatedb,usesuper
          FROM [::Database::qualifySysTable pg_user]
      ORDER BY usename"

    setCursor CLOCK

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) delete 0 end

    catch {
        wpg_select $CurrentDB "$sql" r {
            $Win(mclist) insert end [list $r(usename) $r(usesysid) $boolean($r(usecreatedb)) $boolean($r(usesuper))]
        }
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Usergroups


#----------------------------------------------------------
# ::Mainlib::cmd_Scripts --
#
#     Handles when the Scripts section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Scripts {} {

    global CurrentDB
    variable Win

    set sql "
        SELECT scriptname 
          FROM Pga_scripts 
      ORDER BY scriptname"

    setCursor CLOCK

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns [list 0 [intlmsg Name] left]


    catch {
	wpg_select $CurrentDB "$sql" rec {
            $Win(mclist) insert end [list $rec(scriptname)]
	}
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Scripts

#----------------------------------------------------------
# ::Mainlib::cmd_Images --
#
#     Handles when the Images section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Images {} {

    global CurrentDB
    variable Win

    set sql "
        SELECT imagename 
          FROM Pga_images 
      ORDER BY imagename"

    setCursor CLOCK

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns [list 0 [intlmsg Name] left]


    catch {
	wpg_select $CurrentDB "$sql" rec {
            $Win(mclist) insert end [list $rec(imagename)]
	}
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Images


#----------------------------------------------------------
# ::Mainlib::cmd_Sequences --
#
#     Handles when the Sequences section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Sequences {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(pgversion,$id)]} {
        set Connections::Conn(pgversion,$id) \
            [::Database::getPgVersion $CurrentDB]
    }

    if {[string match "" $VER]} {
        showError [intlmsg "Could not find PG Version of the database"]
        return
    }

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set sql [::Database::getSequencesList $CurrentDB $pg 1 1]

    setCursor CLOCK

    set cols [list]
    if {$VER>=7.3} {
        lappend cols 0 [intlmsg Schema] left
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Owner] left 0 [intlmsg OID] left

    $Win(mclist) configure \
        -columns $cols

    $Win(mclist) columnconfigure 2 -sortmode dictionary

    $Win(mclist) delete 0 end

    wpg_select $CurrentDB "$sql" r {
        if {$VER>=7.3} {
            $Win(mclist) insert end \
                [list $r(nspname) $r(relname) $r(usename) $r(relfilenode)]
        } else {
            $Win(mclist) insert end \
                [list $r(relname) $r(usename) $r(relfilenode)]
        }
    }

    setCursor DEFAULT

    return
}; # end proc ::Mainlib::cmd_Sequences


#----------------------------------------------------------
# ::Mainlib::cmd_Types --
#
#   Handles when the Types section is selected
#
# Arguments:
#   none
#
# Results:
#   none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Types {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Owner] left 0 [intlmsg Type] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getTypesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if { $VER >= 7.3 } {
            set L [list $r(nspname) $r(typname) $r(usename) $r(typtype)]
        } else {
            set L [list $r(typname) $r(usename) $r(typtype)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Types


#----------------------------------------------------------
# ::Mainlib::cmd_Domains --
#
#   Handles when the Domains section is selected
#
# Arguments:
#   none
#
# Results:
#   none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Domains {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    } else {
        lappend cols 0 [intlmsg Unavailable] left
        $Win(mclist) delete 0 end
        $Win(mclist) configure \
            -columns $cols
        # no DOMAINS before 7.3
        showError [intlmsg "You must upgrade to PostgreSQL 7.3 or later to use this feature."]
        return
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Owner] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getTypesList $CurrentDB $pg 1 1 "d"]

    wpg_select $CurrentDB "$sql" r {
        set L [list $r(nspname) $r(typname) $r(usename)]
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Domains


#----------------------------------------------------------
# ::Mainlib::cmd_Triggers --
#
#   Handles when the Triggers section is selected
#
# Arguments:
#   none
#
# Results:
#   none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Triggers {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Table] left 0 [intlmsg Name] left 0 [intlmsg Function] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getTriggersList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(relname) $r(tgname) $r(proname)]
        } else {
            set L [list $r(relname) $r(tgname) $r(proname)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Triggers


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Indexes {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Table] left 0 [intlmsg Name] left 0 [intlmsg Columns] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getIndexesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(tablename) $r(indexname) $r(indnatts)]
        } else {
            set L [list $r(tablename) $r(indexname) $r(indnatts)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Indexes


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Rules {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Table] left 0 [intlmsg Name] left 0 [intlmsg Event] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getRulesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(relname) $r(rulename) $r(ev_type)]
        } else {
            set L [list $r(relname) $r(rulename) $r(ev_type)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Rules


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Languages {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Trusted] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getLanguagesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        set L [list $r(lanname) $r(lanpltrusted)]
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Languages


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Casts {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    lappend cols 0 [intlmsg Source] left 0 [intlmsg Target] left 0 [intlmsg Function] left 0 [intlmsg Context] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getCastsList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        set L [list $r(castsource) $r(casttarget) $r(castfunc)]
        if {[string match "a" $r(castcontext)]} {
            lappend L "ASSIGNMENT"
        } elseif {[string match "e" $r(castcontext)]} {
            lappend L "EXPLICIT"
        } else {
            lappend L "IMPLICIT"
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Casts


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Operators {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Function] left 0 [intlmsg Owner] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getOperatorsList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(oprname) $r(proname) $r(usename)]
        } else {
            set L [list $r(oprname) $r(proname) $r(usename)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Operators


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Operatorclasses {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Method] left 0 [intlmsg Owner] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getOperatorClassesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(opcname) $r(amname) $r(usename)]
        } else {
            set L [list $r(opcname) $r(amname) $r(usename)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Operatorclasses


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Aggregates {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg "Transfer Type"] left 0 [intlmsg "Transfer Function"] left 0 [intlmsg Owner] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getAggregatesList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(aggname) $r(transtypname) $r(aggtransfn) $r(usename)]
        } else {
            set L [list $r(aggname) $r(transtypname) $r(aggtransfn) $r(usename)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Aggregates


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Conversions {} {

    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set cols [list]
    if { $VER >= 7.3 } {
        set cols [list 0 [intlmsg Schema] left]
    }
    lappend cols 0 [intlmsg Name] left 0 [intlmsg Source] left 0 [intlmsg Destination] left 0 [intlmsg Function] left 0 [intlmsg Owner] left

    $Win(mclist) delete 0 end

    $Win(mclist) configure \
        -columns $cols

    setCursor CLOCK

    set sql [::Database::getConversionsList $CurrentDB $pg 1 1]

    wpg_select $CurrentDB "$sql" r {
        if {$VER >= 7.3} {
            set L [list $r(nspname) $r(conname) $r(conforencoding) $r(contoencoding) $r(proname) $r(usename)]
        } else {
            # do conversions even exist before 7.4 ? hmm
            set L [list $r(conname) $r(conforencoding) $r(contoencoding) $r(proname) $r(usename)]
        }
        $Win(mclist) insert end $L
    }

    setCursor DEFAULT

    return
}; # end proc ::Mainlib::cmd_Conversions


#----------------------------------------------------------
# ::Mainlib::cmd_Tables --
#
#     Handles when the Tables section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Tables {} {

    global CurrentDB PgAcVar
    variable Win
    variable boolean

    set cols [list 0 [intlmsg Name] left 0 [intlmsg Owner] left 0 [intlmsg OID] left]
    lappend cols 0 [intlmsg Tuples] left 0 [intlmsg Attributes] left

	
    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(pgversion,$id)]} {
	set Connections::Conn(pgversion,$id) [::Database::getPgVersion $CurrentDB]
    }

    #set VER $::Connections::Conn(pgversion,$id)

    if {[string match "" $VER]} {
	showError [intlmsg "Could not find PG Version of the database"]
	return
    }

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    if {![info exists ::Connections::Conn(viewpgaccess,$id)]} {
        set ::Connections::Conn(viewpgaccess,$id) $PgAcVar(pref,pgaccesstables)
    }
    set pga $::Connections::Conn(viewpgaccess,$id)

    set sql [::Database::getTablesList $CurrentDB $pg $pga 1 1]

    if {$VER < 7.3} {
        set cols [list]
        set int [list 0 1 2 3 4]
    } else {
        set cols [list 0 [intlmsg Schema] left]
        set int [list 0 1 2 3 4 5]
    }

    lappend cols 0 [intlmsg Name] left 0 [intlmsg Owner] left 0 [intlmsg OID] left
    lappend cols 0 [intlmsg Tuples] left 0 [intlmsg Attributes] left

    $Win(mclist) configure \
        -columns $cols

    foreach C $int {
	    $Win(mclist) columnconfigure $C -sortmode dictionary
	}

    $Win(mclist) delete 0 end

    setCursor CLOCK
    wpg_select $CurrentDB "$sql" r {
		if {$VER >= 7.3} {
		    set L [list $r(nspname) $r(relname) $r(usename) $r(relfilenode) $r(reltuples) $r(relnatts)]
		} else {
		    set L [list $r(relname) $r(usename) $r(relfilenode) $r(reltuples) $r(relnatts)]
		}
        $Win(mclist) insert end $L
	     
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Tables

#----------------------------------------------------------
# ::Mainlib::cmd_Diagrams --
#
#     Handles when the Diagrams section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Diagrams {} {
    global CurrentDB
    variable Win

    set sql "
        SELECT diagramname 
          FROM Pga_diagrams 
      ORDER BY diagramname"

    $Win(mclist) configure \
        -columns [list 0 [intlmsg Name] left]

    $Win(mclist) delete 0 end

    setCursor CLOCK
    catch {
	wpg_select $CurrentDB "$sql" rec {
		$Win(mclist) insert end [list $rec(diagramname)]
	}
    }
    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Diagrams

#----------------------------------------------------------
# ::Mainlib::cmd_Views --
#
#     Handles when the Views section is selected
#
# Arguments:
#  none
#
# Results:
#  none returned
#----------------------------------------------------------
#
proc ::Mainlib::cmd_Views {} {

    global PgAcVar
    global CurrentDB
    variable Win

    set VER [::Database::getPgVersion $CurrentDB]
    set id [::Connections::getIdFromHandle $CurrentDB]

    if {![info exists ::Connections::Conn(pgversion,$id)]} {
        set Connections::Conn(pgversion,$id) \
            [::Database::getPgVersion $CurrentDB]
    }

    #set VER $::Connections::Conn(pgversion,$id)

    if {[string match "" $VER]} {
        showError [intlmsg "Could not find PG Version of the database"]
        return
    }

    if {![info exists ::Connections::Conn(viewsystem,$id)]} {
        set ::Connections::Conn(viewsystem,$id) $PgAcVar(pref,systemtables)
    }
    set pg $::Connections::Conn(viewsystem,$id)

    set sql [::Database::getViewsList $CurrentDB $pg 1 1]

    setCursor CLOCK

    if {$VER < 7.3} {
        set cols [list]
        set int [list 0 1 2 3]
    } else {
        set cols [list 0 [intlmsg Schema] left]
        set int [list 0 1 2 3 4]
    }

    lappend cols 0 [intlmsg Name] left 0 [intlmsg Owner] left
    lappend cols 0 [intlmsg OID] left 0 [intlmsg Attributes] left

    $Win(mclist) configure \
        -columns $cols

    foreach C $int {
        $Win(mclist) columnconfigure $C -sortmode dictionary
    }

    $Win(mclist) delete 0 end

    wpg_select $CurrentDB "$sql" r {
        if {$VER < 7.3} {
            $Win(mclist) insert end \
                [list $r(relname) $r(usename) $r(relfilenode) $r(relnatts)]
        } else {
            $Win(mclist) insert end \
                [list $r(schemaname) $r(viewname) $r(usename) $r(relfilenode) $r(relnatts)]
        }
    }

    setCursor DEFAULT

    return

}; # end proc ::Mainlib::cmd_Views


#----------------------------------------------------------
#----------------------------------------------------------
#
proc ::Mainlib::delete_function {objname} {

    sql_exec noquiet "DROP FUNCTION $objname"

}; # end proc ::Mainlib::delete_function


#------------------------------------------------------------
# ::Mainlib::get_dwlb_Selection --
#
#    This just returns the selection in the mclistbox.
#    If There is a "Schema" column, then we return
#    "Schema.Table" if "Tables" is selected,
#    "Schema.View" if "Views" is selected,
#    likewise for Functions and Sequences, exceptions:
#       Triggers = Schema.Table.Trigger
#       Indexes = Schema.Table.Index
#       Rules = Schema.Table.Rule
#       Aggregates = Schema.Aggregate.TransferType.TransferFunction
#       Casts = Source.Target
#
# Arguments:
#    nameonly_  set to 1 if we want to get JUST the name of
#               the object selected, ie. no schema, no extra
#               stuff separated by .'s
#               defaults to 0 to give all sorts of stuff as
#               described in the comments above
#
# Results:
#    returns the first item in the mclistbox that is
#    selected.
#
# Comments:
#   this would be much cleaner here and elsewhere if OID
#   could be associated with items in the tablelist pane,
#   not necessarily display the OID column, just keep track
#   of it with a hidden tag
#------------------------------------------------------------
#
proc ::Mainlib::get_dwlb_Selection {{nameonly_ 0}} {

    global PgAcVar
    variable Win

    set temp [$Win(tree) selection get]
    if {$temp==""} return "";
    set PgAcVar(activetab) [lindex [split $temp -] 0]

    set temp [$Win(mclist) curselection]

    if {$temp == ""} {return ""}

    set first [lindex [$Win(mclist) cget -columns] 1]

    set retval ""

    if {[string match [intlmsg "Schema"] $first]} {
        if {$PgAcVar(activetab)=="Triggers" \
         || $PgAcVar(activetab)=="Indexes" \
         || $PgAcVar(activetab)=="Rules"} {
            if {$nameonly_==1} {
                set retval [lindex [$Win(mclist) get $temp] 2]
            } else {
                set retval [join [lrange [$Win(mclist) get $temp] 0 2] .]
            }
        } elseif {$nameonly_==1} {
            set retval [lindex [$Win(mclist) get $temp] 1]
        } elseif {$PgAcVar(activetab)=="Aggregates"} {
            set retval [join [lrange [$Win(mclist) get $temp] 0 3] .]
        } else {
            set retval [join [lrange [$Win(mclist) get $temp] 0 1] .]
        }
    } else {
        if {$PgAcVar(activetab)=="Triggers" \
         || $PgAcVar(activetab)=="Indexes" \
         || $PgAcVar(activetab)=="Rules"} {
            if {$nameonly_==1} {
                set retval [lindex [$Win(mclist) get $temp] 1]
            } else {
                set retval [join [lrange [$Win(mclist) get $temp] 0 1] .]
            }
        } elseif {$nameonly_==1} {
            set retval [lindex [$Win(mclist) get $temp] 0]
        } elseif {$PgAcVar(activetab)=="Aggregates"} {
            set retval [join [lrange [$Win(mclist) get $temp] 0 2] .]
        } elseif {$PgAcVar(activetab)=="Casts"} {
            set retval [join [lrange [$Win(mclist) get $temp] 0 1] .]
        } else {
            set retval [lindex [$Win(mclist) get $temp] 0]
        }
    }

    return $retval

}; # end proc ::Mainlib::get_dwlb_Selection




proc ::Mainlib::sqlw_display {msg} {
	if {![winfo exists .pgaw:SQLWindow]} {return}
	.pgaw:SQLWindow.f.t insert end "$msg\n\n"
	.pgaw:SQLWindow.f.t see end
	set nrlines [lindex [split [.pgaw:SQLWindow.f.t index end] .] 0]
	if {$nrlines>500} {
		.pgaw:SQLWindow.f.t delete 1.0 3.0
	}
}


#----------------------------------------------------------
# ::Mainlib::init_pga_tables --
#
#   Creates PGA tables in database
#
# Arguments:
#   dbh_    an optional database handle
#
# Results:
#   none returned
#----------------------------------------------------------
#
proc ::Mainlib::init_pga_tables {{dbh_ ""}} {

    global PgAcVar CurrentDB
    variable Win

    if {[string match "" $dbh_]} {
        set dbh_ $CurrentDB
    }

    if { [info exists PgAcVar(PGACCESS_NOPGATABLESINIT)]
      && $PgAcVar(PGACCESS_NOPGATABLESINIT) == 1 } {
        return
    }

    setCursor CLOCK

    set pga_tabs(pga_queries) [list]
    append pga_tabs(pga_queries) "queryname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_queries) "querytype CHAR(1),"
    append pga_tabs(pga_queries) "querycommand TEXT,"
    append pga_tabs(pga_queries) "querytables TEXT,"
    append pga_tabs(pga_queries) "querylinks TEXT,"
    append pga_tabs(pga_queries) "queryresults TEXT,"
    append pga_tabs(pga_queries) "querycomments TEXT"

    set pga_tabs(pga_forms) [list]
    append pga_tabs(pga_forms) "formname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_forms) "formsource TEXT"

    set pga_tabs(pga_scripts) [list]
    append pga_tabs(pga_scripts) "scriptname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_scripts) "scriptsource TEXT"

    set pga_tabs(pga_images) [list]
    append pga_tabs(pga_images) "imagename VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_images) "imagesource TEXT"

    set pga_tabs(pga_reports) [list]
    append pga_tabs(pga_reports) "reportname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_reports) "reportsource TEXT,"
    append pga_tabs(pga_reports) "reportbody TEXT,"
    append pga_tabs(pga_reports) "reportprocs TEXT,"
    append pga_tabs(pga_reports) "reportoptions TEXT,"
    append pga_tabs(pga_reports) "reportfilter TEXT,"
    append pga_tabs(pga_reports) "reportorderby TEXT"

    set pga_tabs(pga_diagrams) [list]
    append pga_tabs(pga_diagrams) "diagramname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_diagrams) "diagramtables TEXT,"
    append pga_tabs(pga_diagrams) "diagramlinks TEXT"

    set pga_tabs(pga_graphs) [list]
    append pga_tabs(pga_graphs) "graphname VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_graphs) "graphsource TEXT,"
    append pga_tabs(pga_graphs) "graphcode TEXT"

    set pga_tabs(pga_layout) [list]
    append pga_tabs(pga_layout) "tablename VARCHAR(64) PRIMARY KEY,"
    append pga_tabs(pga_layout) "nrcols INT2,"
    append pga_tabs(pga_layout) "colnames TEXT,"
    append pga_tabs(pga_layout) "colwidth TEXT"

    # Check for pga_ tables

    set sql "
        SELECT relname
          FROM [::Database::qualifySysTable pg_class]
         WHERE relname IN ('[join [array names pga_tabs] ',']')"
    set pgres [wpg_exec $dbh_ $sql]

    if { $PgAcVar(pgsql,status) != "PGRES_TUPLES_OK" } {
        showError "[intlmsg {FATAL ERROR searching for PgAccess system tables}] : $PgAcVar(pgsql,errmsg)\nStatus:$PgAcVar(pgsql,status)"
        catch {pg_disconnect $dbh_}
        $Win(statuslabel) configure \
            -text [intlmsg "FATAL ERROR searching for PgAccess system tables"]
        return

    # we either have no pga tables, or we are a couple pga tables short
    } elseif { [pg_result $pgres -numTuples] < [llength [array names pga_tabs]] } {
        pg_result $pgres -assign curr_tabs

        set tempsql "BEGIN;"

        # only create the missing pga tables
        foreach {table structure} [array get pga_tabs] {
            if { ![info exists curr_tabs($table)] } {
                # if they don't want persistent pga_ tables, just make em TEMPs
                append tempsql "CREATE"
                if { [info exists PgAcVar(PGACCESS_TEMP)]
                  && $PgAcVar(PGACCESS_TEMP) == 1 } {
                    append tempsql " TEMP"
                }
                append tempsql " TABLE $table ($structure);"
            }
        }

        append tempsql "END;"
        sql_exec quiet $tempsql

    # we have all the pga tables, so we just need to make
    # sure that they have the right columns
    } else {
        pg_result $pgres -assign curr_tabs
        foreach {k table} [array get curr_tabs] {
            set structure $pga_tabs($table)
            foreach fieldspec [split $structure ,] {
                set field [lindex [split $fieldspec] 0]
                set lcols [::Database::getColumnsList $table]
                if { [lsearch -exact $lcols $field] == -1 } {
                    sql_exec quiet "
                       ALTER TABLE [::Database::quoteObject $table]
                        ADD COLUMN $fieldspec"
                }
            }; # end foreach fieldspec
        }; # end foreach curr_tabs
    }

    catch {pg_result $pgres -clear}

    setCursor DEFAULT

}; # end proc ::Mainlib::init_pga_tables


#----------------------------------------------------------
# ::Mainlib::fillTree --
#
#    Fills the tree widget with the DB information
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
#### IS THIS USED ANYMORE ????????????????????????????
proc ::Mainlib::fillTree {} {

    global PgAcVar Win CurrentDB
    variable Win

    ##
    ##  Once we go to multiple connections, this will
    ##  a real list of computers. Now it defaults to 
    ##  the currentdb host
    ##
    foreach M [::Connections::getFQHosts] {
        #if {[string match "" $M]} {set M localhost}

        #$::Mainlib::Win(tree) insert end root __host__-$M \
            #-text "$M" \
      	#-image [image create photo -data $::Mainlib::_base64(online:rx)]

	    addHostNode $M
    
        ##
        ##  Right now we just handle the currentdb
        ##
        foreach N [::Connections::getDbs $M] {
            addDbNode $M $N
        }

    }

    ##
    ##  This just opens up the tree to the "current DB"
    ##  assuming that the user wants to start there
    ##  if empty string, then unix sockets connection
    ##
    set host   $PgAcVar(currentdb,host)
    set pgport $PgAcVar(currentdb,pgport)
    set dbname $PgAcVar(currentdb,dbname)
    if {[string match "" $host]} {
        if {[$Win(tree) exists __host__-sockets]} {
            $Win(tree) opentree __host__-sockets 0
        }
        if {[$Win(tree) exists __db__-sockets-$dbname]} {
            $Win(tree) opentree __db__-sockets-$dbname
        }
    } else {
        if {[$Win(tree) exists __host__-${host}:${pgport}]} {
            $Win(tree) opentree __host__-${host}:${pgport} 0
        }
        if {[$Win(tree) exists __db__-${host}:${pgport}-${dbname}]} {
            $Win(tree) opentree __db__-${host}:${pgport}-${dbname}
        }
    }

    ##
    ## This is if there is an autoexec script in the scripts db
    ##
    if {([info exists PgAcVar(activetab)]) && (![string match "" $PgAcVar(activetab)])} {
        set node ${host}:${pgport}-${dbname}-$PgAcVar(activetab)
        select 1 $node
    }

    return
    
}; # end proc ::Mainlib::fillTree 

#------------------------------------------------------------
# ::Mainlib::addHostNode --
#
#    This adds a host node to the tree list
#
# Arguments:
#    host_    then hostname to use for the tree node
#
# Results:
#    none returned
#------------------------------------------------------------
#
proc ::Mainlib::addHostNode {host_ {id_ 0}} {

    global CurrentDB
    variable Win

    set dbh ""

    if {[string match "" $dbh]} {
        set dbh $CurrentDB
    }

    set id $id_
    if {$id_ == 0} {
        set id [::Connections::getIdFromHandle $dbh]
    }

    set port $::Connections::Conn(pgport,$id)
    set txt ${host_}:$port
    set img ::icon::network_local-16

    if {[string match "" $host_]} {
        set host_ sockets
        set txt "local (sockets)"
        set img ::icon::system-16
    }

    #set hoststr [encode host $host_]
    set hoststr host-$id
    if {[$Win(tree) exists $hoststr]} {return}

    $::Mainlib::Win(tree) insert end root $hoststr \
        -text "$txt" \
      	-image $img

    return

}; # end proc ::Mainlib::addHostNode

#------------------------------------------------------------
# ::Mainlib::addDbNode --
#
#    This adds a database node to the tree list
#
# Arguments:
#    host_    then hostname for this db
#    db_      the db name to use for the db node
#
# Results:
#    none returned
#------------------------------------------------------------
#
proc ::Mainlib::addDbNode {host_ db_ {id_ 0}} {

    global CurrentDB
    variable Win
    variable img

    set dbh $CurrentDB

    set id $id_
    if {$id_ == 0} {
        set id [::Connections::getIdFromHandle $dbh]
    }
    set V [::Database::getPgVersion $dbh]

    set i [image create photo -data $::Mainlib::_base64(si_grid)]

    set port ""
    if {[string match "" $host_]} {
        set host_ sockets
    } else {
        set port [lindex [split $host_ :] 1]
        if {[string length $port] != 0} {
            set port "($port)"
        }
    }

    #set dbstr [encode db $host_ $db_]
    set dbstr db-$id
    #set hoststr [encode host $host_]
    set hoststr host-$id

    if {[$Win(tree) exists $dbstr]} {return}

    if {![$Win(tree) exists $hoststr]} {
	if {[string match "sockets" $host_]} {
	    addHostNode "" $id
        } else {

            addHostNode $host_ $id
        }
    }

    $::Mainlib::Win(tree) insert end $hoststr $dbstr \
        -text "$db_ $port" \
        -image [image create photo -data $::Mainlib::_base64(si_sql)]

    foreach I $::PgAcVar(pgtablist) {
        if {!($V < 7.3 \
          && [lsearch [list "Domains" "Casts" "Conversions"] $I]!=-1)} {

            #set objstr [encode object $host_ $db_ $I]
            set objstr ${I}-$id

            $::Mainlib::Win(tree) insert end $dbstr $objstr \
               -text [intlmsg $I] \
               -image $img($I) \
               -fill blue
        }
    }

    foreach I $::PgAcVar(pgatablist) {

        #set objstr [encode object $host_ $db_ $I]
        set objstr ${I}-$id

        $::Mainlib::Win(tree) insert end $dbstr $objstr \
           -text [intlmsg $I] \
           -image $img($I) \
           -fill red
    }

    return

}; # end proc ::Mailib::addDbNode

#----------------------------------------------------------
# ::Mainlib::nodeOpen --
#
#
# Arguments:
#    node    This gets passed from the bind on the node
#            in the tree. It is the node that was selected
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::nodeOpen {node} {

    variable Win


    #foreach {junk host db} [split $node -] break
    foreach {type id} [split $node -] break

    set host $::Connections::Conn(host,$id)
    set db $::Connections::Conn(dbname,$id)
    set port $::Connections::Conn(pgport,$id)

    #if {(![string match "__db__" $type]) && (![string match "__host__" $type])} {
	#set db $host
        #set host $junk
    #}

    if {[string match "sockets" "$host"]} {
	$Win(hostlabel) configure \
            -text "local (sockets)"
    } else {
        $Win(hostlabel) configure \
            -text "${host}:$port"
    }

    $Win(dblabel) configure \
        -text "${db}"

    set nhost [string map {sockets ""} $host]

    #set id [::Connections::getIds $nhost $db]
    if {[string match "" $id]} {
	   set v ""
    } else {
	if {![info exists ::Connections::Conn(pgversion,$id)]} {
	    set dbh [::Connections::getHandles $host $db]
	    set Connections::Conn(pgversion,$id) [::Database::getPgVersion $dbh 0]
	}
	set v $::Connections::Conn(pgversion,$id)
    }
    
    $Win(verlabel) configure \
        -text "PG: $v"
            #-text "PG: [::Database::getPgVersion]"

    return

} ; # end proc ::Mainlib::nodeOpen

#----------------------------------------------------------
# ::Mainlib::select --
#
#
# Arguments:
#    num_    Which button was pressed (1 or 2)
#    node_   This is passed in by the Tree widget. It is
#            the node that is selected.
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::select {num_ node_} {

    global PgAcVar CurrentDB
    variable Win
    variable boolean

    ##
    ##	This is to guard against when someone
    ##	double clicks...it displays the contains
    ##	twice...so this just makes sure that doesn't
    ##	happen
    ##
    if {$num_ == 2} return

    #foreach {type host db entry} [split $node_ -] {break}
    foreach {type id} [split $node_ -] {break}
    set host $::Connections::Conn(host,$id)
    set db $::Connections::Conn(dbname,$id)
    set P $::Connections::Conn(pgport,$id)

    set s [split $host :]
    set H [lindex $s 0]
    #set P [lindex $s 1]

    $Win(tree) selection set $node_

    set PgAcVar(activetab) $type

    switch -- $type {

        host {
            #set host $db
            set db ""
            set entry ""

            set cols [list 0 [intlmsg Name] left 0 [intlmsg Port] left 0 [intlmsg DBs] left]

            $Win(mclist) configure \
                -columns $cols

            $Win(mclist) delete 0 end

            setCursor CLOCK

            $Win(mclist) insert end \
            [list $host $P [llength [$Win(tree) nodes $node_]]]

            setCursor DEFAULT
        }

        db {
            #set host $db
            #set db $entry

            set entry ""

            #set id [::Connections::getIds $host $db]
            if {[info exists ::Connections::Conn(handle,$id)]} {
                set CurrentDB $::Connections::Conn(handle,$id)
            }

            set sql "
                SELECT U.usename,D.*
                  FROM [::Database::qualifySysTable pg_database] D,
                       [::Database::qualifySysTable pg_user] U
                 WHERE datname = '$db'
                   AND U.usesysid = D.datdba"

            set id [::Connections::getIds $host $db]
            if {[info exists ::Connections::Conn(handle,$id)]} {
                set CurrentDB $::Connections::Conn(handle,$id)
                set ::PgAcVar(currentdb,pgport) $::Connections::Conn(pgport,$id)
                set ::PgAcVar(currentdb,username) $::Connections::Conn(username,$id)
                set ::PgAcVar(currentdb,password) $::Connections::Conn(password,$id)
            }

            set cols [list 0 [intlmsg Owner] left 0 [intlmsg Encoding] left]
            lappend cols 0 [intlmsg Template?] left 0 [intlmsg Connection?] left
            lappend cols 0 [intlmsg Sysoid] left

            $Win(mclist) configure \
                -columns $cols

            $Win(mclist) delete 0 end

            setCursor CLOCK

            if {[catch {wpg_select $CurrentDB "$sql" r {
                $Win(mclist) insert end \
                    [list $r(usename) $r(encoding) $boolean($r(datistemplate)) $boolean($r(datallowconn)) $r(datlastsysoid)]
            }}]} {
                ::Mainlib::Database:Close
            }

            setCursor DEFAULT

        }

        default {
            #set host $comp

            #foreach {host db entry} [split $node_ -] {break}
            set entry $type

            set id [lrange [::Connections::getIds $host $db] end end]
            if {[info exists ::Connections::Conn(handle,$id)]} {
                set CurrentDB $::Connections::Conn(handle,$id)
                set ::PgAcVar(currentdb,pgport) $::Connections::Conn(pgport,$id)
                set ::PgAcVar(currentdb,username) $::Connections::Conn(username,$id)
            }

            if {[lsearch $PgAcVar(tablist) $entry] >= 0} {
                if {[catch {cmd_$entry}]} {
                    showError [intlmsg "Could not open $entry node"]
                    setCursor DEFAULT
                }
            }
        }

    }; # end switch

    set ::PgAcVar(currentdb,host) $host
    #set ::PgAcVar(currentdb,pgport) $port
    set ::PgAcVar(currentdb,dbname) $db
    set ::PgAcVar(pref,lasthost) $host
    set ::PgAcVar(pref,lastdb) $db

    set PgAcVar(activetab) $type

    nodeOpen $node_

    return

}; # end proc select

#----------------------------------------------------------
# ::Mainlib::DatabaseCmd --
#
#    Selects the command for the correct menu item
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::DatabaseCmd {item_} {

    switch -- $item_ {
        Vacuum       {::Database::vacuum}
        Import_table {::ImportExport::setup 1}
        Export_table {::ImportExport::setup 0}
        PgAckage_save {::PgAckages::init save}
        PgAckage_load {::PgAckages::init load}
        PgAccess_init {::Mainlib::init_pga_tables}
        Preferences  {::Preferences::configure}
        Exit         {::Mainlib::Exit}
        Open         {::Connections::openConnWin 0 1 0 1}
        Debug        {::Debug::open}
        default      {::Mainlib::Database:$item_}
    }; # end switch

    return

}; # end proc ::Mainlib::DatabaseCmd

#----------------------------------------------------------
# ::Mainlib::Database:New --
#
#    Opens the new database wizard
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::Database:New {} {

    ::NewDBWiz::start

    return

}; # end proc ::Mainlib::Database:New

#----------------------------------------------------------
# ::Mainlib::Database:Manage --
#
#    Window to manages the connections info
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::Database:Manage {} {

    global PgAcVar

    variable state_fields

    set header [list [intlmsg "host"] [intlmsg port] [intlmsg "dbname"]]
    lappend header [intlmsg "autoload"] [intlmsg "show system tables"]
    lappend header [intlmsg "show pgaccess tables"] [intlmsg "save passwords"]
    #lappend header [intlmsg "open"] [intlmsg "delete"]
  
    if {[winfo exists .manage]} {
        wm deiconify .manage
        raise .manage
        return
    } else {
        toplevel .manage
    }

    wm protocol .manage WM_DELETE_WINDOW {
        ::Connections::save
        destroy .manage
    }

    set tblhead [list 0 [intlmsg id] left]
    set cnt 0
    foreach H $header {
        set justify left
        if {$cnt > 2} {
            set justify center
        }
        lappend tblhead 0 $H $justify
        incr cnt
    }

    wm title .manage "Manage Connections"

    set bbox [ButtonBox .manage.bbox -spacing 2]

    $bbox add \
        -image ::icon::fileopen-22 \
        -padx 1 \
        -pady 1 \
        -relief link \
        -command [list ::Mainlib::manage_Open] \
        -helptext [intlmsg "Open Selected Connection"]

    $bbox add \
        -image ::icon::edittrash-22 \
        -padx 1 \
        -pady 1 \
        -relief link \
        -command [list ::Mainlib::manage_Delete] \
        -helptext [intlmsg "Delete Selected Connection"]

    scrollbar .manage.xscroll \
        -orient horizontal \
        -command [list .manage.tablelist xview]

    scrollbar .manage.yscroll \
        -orient vertical \
        -command [list .manage.tablelist yview]

    set table [tablelist::tablelist .manage.tablelist \
        -labelcommand tablelist::sortByColumn \
        -width 80 \
        -font PGfont2 \
        -labelfont PGfont \
        -stretch all \
        -columns $tblhead \
        -selectbackground #DDDDDD \
        -selectforeground #708090 \
        -xscrollcommand [list .manage.xscroll set] \
        -yscrollcommand [list .manage.yscroll set]]

    bind [$table bodypath] <Double-ButtonPress-1> [list ::Mainlib::changeState %x %y  %W]
    bind [$table bodypath] <ButtonRelease-3> \
    [list ::Mainlib::manageMenu .manage.popup %W %X %Y %x %y 0]

    #$table columnconfigure 0 -hide 1

    set row 0
    foreach H [::Connections::getHosts] {
        if {[string match "" $H]} {set H sockets}

        foreach D [::Connections::getDbs $H] {
            if {[string length $D]>0 && [string length $H]>0} {
                set i [lindex [::Connections::getIds $H $D] 0]

                set P $::Connections::Conn(pgport,$i)
                .manage.tablelist insert end [list $i $H $P $D]
                set statecnt 4
                foreach T $state_fields {
                    if {$::Connections::Conn($T,$i)} {
                        .manage.tablelist cellconfigure $row,$statecnt \
                            -image ::icon::actcheck16
                    }
                    incr statecnt
                }

                incr row
            }
        }
    }

    menu .manage.popup
    foreach PU {Open Delete} {

        .manage.popup add command \
            -label [intlmsg "$PU"] \
            -command ::Mainlib::manage_$PU
    }


###    button .manage.btnsave \
###        -command ::Connections::initSave \
###        -padx 9 \
###        -pady 3 \
###        -text [intlmsg Save]

    #button .manage.btncancel \
        #-command {::Connections::save; Window destroy .manage} \
        #-padx 9 \
        #-pady 3 \
        #-text [intlmsg Close]
    

    #grid .manage.btncancel \
        #-sticky ew

    grid $bbox -sticky w -row 0 -column 0
    grid .manage.tablelist -sticky news -row 1 -column 0
    grid .manage.yscroll -sticky ns -column 1 -row 1
    grid .manage.xscroll -sticky ew -row 2 -column 0

    grid columnconfigure .manage 0 -weight 2
    grid rowconfigure .manage 1 -weight 2

    return

}; # end proc ::Mainlib::Database:Manage

#----------------------------------------------------------
# ::Mainlib::manage_Delete --
#
#    Deletes a connection via the manage interface
#
# Arguments:
#    id_    the id of the connection
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::manage_Delete {} {

    set cur [.manage.tablelist curselection]

    if {[string length $cur] == 0} {return}

    ::Connections::deleteInfo [lindex [.manage.tablelist get $cur] 0]
    .manage.tablelist delete $cur $cur

    return
}; # end ::Mainlib::manage_Delete

#----------------------------------------------------------
# ::Mainlib::manage_Open --
#
#    Opens a connection via the manage interface
#
# Arguments:
#    id_    the id of the connection
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::manage_Open {} {

    set cur [.manage.tablelist curselection]

    if {[string length $cur] == 0} {return}

    ::Connections::openConnWin [lindex [.manage.tablelist get $cur] 0]

    return
    
}; #end ::Mainlib::manage_Open

#----------------------------------------------------------
# ::Mainlib::manageMenu --
#
#    sets up the popup for the manage interface
#
# Arguments:
#    Menu_ widget where the event occurred
#    W     window where event happened
#    X     the x coordinate where the mouse was
#    Y     the y coordinate where the mouse was
#    x     the x coordinate where the mouse was
#    y     the y coordinate where the mouse was
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::manageMenu {Menu_ W_ X_ Y_ x_ y_ opt_} {

    .manage.tablelist selection clear 0 end
    set x [expr {$x_ + [winfo x $W_]}]
    set y [expr {$y_ + [winfo y $W_]}]

    .manage.tablelist selection set [.manage.tablelist nearest $y]

    tk_popup $Menu_ $X_ $Y_ $opt_

    return
    
}; # end ::Mainlib::manageMenu


#----------------------------------------------------------
# ::Mainlib::changeState --
#
#    changes the state of the options in the manage interfacec
#
# Arguments:
#    x     the x coordinate where the mouse was
#    y     the y coordinate where the mouse was
#    W     the widget where the event occurred
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::changeState {x y W} {

    variable state_fields

    set x [expr {$x + [winfo x $W]}]
    set y [expr {$y + [winfo y $W]}]
    set cell [.manage.tablelist nearestcell $x $y]

    set row [lindex [split $cell ,] 0]
    set col [lindex [split $cell ,] 1]

    set curstate [.manage.tablelist cellcget $cell -image]

    set fld [lindex $state_fields [expr {$col - 4}]]
    set cid [lindex [lindex [.manage.tablelist get $row $row] 0] 0]

    if {![info exists ::Connections::Conn($fld,$cid)]} {return}

    if {$::Connections::Conn($fld,$cid) == 0} {
        .manage.tablelist cellconfigure $cell \
             -image ::icon::actcheck16

        set ::Connections::Conn($fld,$cid) 1

    } else {
        .manage.tablelist cellconfigure $cell \
            -image {}

        set ::Connections::Conn($fld,$cid) 0
    }

}; # end 


#----------------------------------------------------------
# ::Mainlib::Database:Close --
#
#    Closes the database connection to the current DB
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::Database:Close {} {

    variable Win

    set node [$Win(tree) selection get]
    if {([string match "" $node]) || ([string match "host-*" $node])} {return}


    #foreach {H D E} [split $node -] break
    foreach {type id} [split $node -] break

    set H $::Connections::Conn(host,$id)
    set D $::Connections::Conn(dbname,$id)

    #if {[string match "db-*" $node]} {
        #set H $D
        #set D $E
    #}

    #catch {pg_disconnect $::CurrentDB}

    catch {pg_disconnect [::Connections::getHandles $H $D]}
    $Win(tree) delete [$Win(tree) nodes db-${id}]
    $Win(tree) delete db-${id}

    $Win(mclist) delete 0 end
	$Win(mclist) configure \
	    -columns [list 0 "" left]

    if {[llength [$Win(tree) nodes host-${id}]] == 0} {
	   $Win(tree) delete host-${id}
	   set h [$Win(tree) nodes root]
	   if {[llength $h] != 0} {
	       select 1 [lindex $h 0]
		   select 1 [lindex [$Win(tree) nodes $h] 0]
	   }
	} else {
	    select 1 [lindex [$Win(tree) nodes host-${id}] 0]
	}

	#set i [::Connections::getIds $H $D]
    #::Connections::deleteInfo $i

    set ::CurrentDB {}
    set ::PgAcVar(currentdb,dbname) {}
    #set ::PgAcVar(statusline,dbname) {}

    foreach L {host db ver} {
	    $Win(${L}label) configure \
		    -text ""
	}


    ::Connections::save

    return
}; # end proc ::Mainlib::Database:Close

#----------------------------------------------------------
# ::Mainlib::Database:SQL_window --
#
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::Database:SQL_window {} {

    Window show .pgaw:SQLWindow

    return

}; # end proc ::Mainlib::Database:SQL_window

#----------------------------------------------------------
# ::Mainlib::Exit --
#
#    Exits PGAccess
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::Exit {} {

    global PgAcVar

    debug "Preparing final cleanup..."

    set PgAcVar(activetab) {}
    debug "Cleared activetab..."

    set PgAcVar(pref,geometry) [wm geometry .]
    debug "Saved geometry..."

    ::Preferences::save
    debug "Saved preferences..."

    ::Connections::save
    debug "Saved connections..."

    # make sure we don't leave any connections in an
    # unproperly closed state
    foreach conn [::Connections::getHandles] {
        catch {pg_disconnect $conn}
        debug "Closing possibly open connection handle $conn..."
    }

    debug "Exiting..."

    exit

}; # end proc ::Mainlib::Exit


#----------------------------------------------------------
# ::Mainlib::ObjectCmd --
#
#    Selects the command for the correct menu item
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::ObjectCmd {item_} {

    cmd_$item_

    return

}; # end proc ::Mainlib::ObjectCmd

#----------------------------------------------------------
# ::Mainlib::ServerCmd --
#
#    Selects the command for the correct menu item
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::ServerCmd {item_} {

    switch -- $item_ {
        Dump_database {::Mainlib::cmd_Dump text}
        PgMonitor     {::::Pgmonitor::openWin}
        HotSyncPGA    {::Connections::save;re_load_namespaces;::Connections::load}
        default       {::Mainlib::cmd_Dump binary}
    }; # end switch

    return

}; # end proc ::Mainlib::ServerCmd

#----------------------------------------------------------
# ::Mainlib::HelpCmd --
#
#    Selects the command for the correct menu item
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::HelpCmd {item_} {

    switch -- $item_ {
        Contents   {::Help::load index}
        PostgreSQL {::Help::load postgresql}
        About      {Window show .pgaw:About}
    }; # end switch

    return

}; # end proc ::Mainlib::HelpCmd

#----------------------------------------------------------
# ::Mainlib::handleToolBar --
#
#    Checks to see if the toolbar needs to be hidden or
#    shown
#
# Arguments:
#    none
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc ::Mainlib::handleToolBar {} {

	global PgAcVar
    variable Win

    if {![info exists PgAcVar(pref,showtoolbar)]} {set PgAcVar(pref,showtoolbar) 1}

	if {$PgAcVar(pref,showtoolbar)} {

	    pack $Win(toolframe) \
	    	-before $Win(csmframe) \
	        -fill x

	} else {

	    pack forget $Win(toolframe)
	}

    return

}; # end proc ::Mainlib::HelpCmd


#------------------------------------------------------------
#------------------------------------------------------------
#
proc ::Mainlib::notEmpty {var_} {

    upvar $var_ V

    if {([info exists V]) && (![string match "" $V])} {
        return 1
    }

    return 0
}; # end proc ::Mainlib::notEmpty

#------------------------------------------------------------
#        THESE IS OBSOLETE
#------------------------------------------------------------
#
proc ::Mainlib::encode {type_ host_ {db_ ""} {object_ ""}} {


    switch -- $type_ {
        host {
            set ret "__host__-[string map {- "%45"} $host_]"
        }
        db   {
            set ret "__db__-[string map {- "%45"} $host_]-[string map {- "%45"} $db_]"
        }
        default {
            set ret "[string map {- "%45"} $host_]-[string map {- "%45"} $db_]-[string map {- "%45"} $object_]"
        }
    }; # end switch

    return $ret
 
}; # end ::Mainlib::encode

#------------------------------------------------------------
#        THESE IS OBSOLETE
#------------------------------------------------------------
#
proc ::Mainlib::decode {str_} {

    set ret [list]
    foreach E [split $str_ -] {
        lappend ret [string map {%45 -} $E]
    }

    return $ret
}; # end ::Mainlib::decode

#----------------------------------------------------------
# vTclWindow.pgaw:Main --
#
#    Builds the main GUI
#
# Arguments:
#    base    this is the base window
#
# Results:
#    none returned
#----------------------------------------------------------
#
proc vTclWindow.pgaw:Main {base} {

    global PgAcVar Win CurrentDB

    if {$base == ""} {
	set base .pgaw:Main
    }
    if {[winfo exists $base]} {
	#wm deiconify $base; return
    }
	#toplevel $base -class Toplevel \
	    #-background #efefef -cursor left_ptr


    ##
    ##  This is a total hack!
    ##  This is to get around the fact that
    ##  alot of other procs reference this window
    ##  which was replaced with the new interface
    ##  Will tear this out when we take care of the
    ##  references from other procs
    ##
    frame .pgaw:Main


    wm geometry . 600x400
	if {([info exists PgAcVar(pref,geometry)]) && (![string match "" $PgAcVar(pref,geometry)])} {
	    wm geometry . $PgAcVar(pref,geometry)
	}
    wm title . "PostgreSQL Access"
	#wm maxsize $base 1280 1024
	#wm minsize $base 1 1
	#wm overrideredirect $base 0
	#wm resizable $base 0 0
	#wm deiconify $base


    # make sure we close everything properly upon exit
    bind $base <Destroy> ::Mainlib::Exit

    set base ""
    set ::Mainlib::Win(menuframe) $base.mf
    set ::Mainlib::Win(toolframe) [frame $base.tbf]
    set ::Mainlib::Win(csmframe) [frame $base.mainf]
    set ::Mainlib::Win(labelframe) [frame $base.labf]

    #option add *Menu.borderWidth 1                   widgetDefault
    #option add *Menu.font $PgAcVar(pref,font_normal) widgetDefault
    #option add *Menu.tearOff 0                       widgetDefault
    #option add *ButtonBox.borderWidth  1             widgetDefault
    #option add *ButtonBox.takeFocus  0               widgetDefault
    #option add *ButtonBox.highLightThickness  0      widgetDefault

    ##
    ##  This is the new style of creating menus
    ##
    menu $::Mainlib::Win(menuframe)
    . configure -menu $::Mainlib::Win(menuframe)

    set mn(Database) [list New Open Manage Close Vacuum]
    lappend mn(Database) sep Import_table Export_table
    lappend mn(Database) sep PgAckage_save PgAckage_load
    lappend mn(Database) sep PgAccess_init
    lappend mn(Database) sep Preferences SQL_window Debug sep Exit
    set mn(Object) [list New Open Design Copy Rename Delete]
    set mn(Server) [list Dump_database Dump_database_(binary) sep PgMonitor sep HotSyncPGA]
    set mn(Help) [list Contents PostgreSQL sep About]

    ##
    ##  This is just a convenience...we loop through
    ##  the different meny items for each main menu
    ##  we assume there is a proc with the same name
    ##  as the label
    ##
    foreach MM {Database Object Server Help} {

        set x [string tolower $MM]

        $::Mainlib::Win(menuframe) add cascade \
            -label [intlmsg $MM] \
            -menu $::Mainlib::Win(menuframe).$x
  
        menu $::Mainlib::Win(menuframe).$x

        foreach M $mn($MM) {

            regsub -all -- {_} $M { } txt

            if {[string match sep $M]} {
                $::Mainlib::Win(menuframe).$x add separator
            } else {
               $::Mainlib::Win(menuframe).$x add command \
                    -label [intlmsg $txt] \
                    -command "::Mainlib::${MM}Cmd $M"
           }
        }; # end foreach sub menu

    }; # end foreach main menu


    ##
    ##  TOOL BAR
    ##
    set ::Mainlib::Win(bbox1) [ButtonBox $::Mainlib::Win(toolframe).bbox -spacing 2]

    DynamicHelp::configure -font PGfont-1 -background white

        $::Mainlib::Win(bbox1) add -image ::icon::connect_creating-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Open] \
            -helptext [intlmsg "Connect to DB"]

        $::Mainlib::Win(bbox1) add -image ::icon::connect_no-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Close] \
            -helptext [intlmsg "Close current connection"]

        $::Mainlib::Win(bbox1) add -image ::icon::filter1-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Vacuum] \
            -helptext [intlmsg "Vacuum current DB"]
        
        $::Mainlib::Win(bbox1) add -image ::icon::down-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Import_table] \
            -helptext [intlmsg "Import Table"]

        $::Mainlib::Win(bbox1) add -image ::icon::up-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Export_table] \
            -helptext [intlmsg "Export Table"]

        $::Mainlib::Win(bbox1) add -image ::icon::start-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd PgAckage_save] \
            -helptext [intlmsg "Save PgAckage"]

        $::Mainlib::Win(bbox1) add -image ::icon::finish-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd PgAckage_load] \
            -helptext [intlmsg "Load PgAckage"]

        $::Mainlib::Win(bbox1) add -image ::icon::configure-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command [list ::Mainlib::DatabaseCmd Preferences] \
            -helptext [intlmsg "Preferences"]

    Separator $::Mainlib::Win(toolframe).sep  -orient vertical

    set ::Mainlib::Win(bbox2) [ButtonBox $::Mainlib::Win(toolframe).bbox2 -spacing 2]


        $::Mainlib::Win(bbox2) add -image ::icon::filenew-22 \
            -padx 1 \
            -pady 1 \
            -relief link \
            -command ::Mainlib::cmd_New \
            -helptext [intlmsg "New Object"]

        $::Mainlib::Win(bbox2) add -image ::icon::fileopen-22 \
            -relief link \
            -padx 1 \
            -pady 1 \
            -command ::Mainlib::cmd_Open \
            -helptext [intlmsg "Open Selected Object"]

        $::Mainlib::Win(bbox2) add -image ::icon::edit-22 \
            -relief link \
            -padx 1 \
            -pady 1 \
            -command ::Mainlib::cmd_Design \
            -helptext [intlmsg "Design Selected Object"]

        $::Mainlib::Win(bbox2) add -image ::icon::editcopy-22 \
            -relief link \
            -padx 1 \
            -pady 1 \
            -command ::Mainlib::cmd_Copy \
            -helptext [intlmsg "Copy Selected Object"]

        $::Mainlib::Win(bbox2) add -image ::icon::move-22 \
            -relief link \
            -padx 1 \
            -pady 1 \
            -command ::Mainlib::cmd_Rename \
            -helptext [intlmsg "Rename Selected Object"]

        $::Mainlib::Win(bbox2) add -image ::icon::edittrash-22 \
            -relief link \
            -padx 1 \
            -pady 1 \
            -command ::Mainlib::cmd_Delete \
            -helptext [intlmsg "Delete Selected Object"]

    ##
    ##   PANED WINDOW
    ##
    set ::Mainlib::Win(panew) [PanedWindow $::Mainlib::Win(csmframe).pane \
        -side bottom \
        -weights available]

    set ::Mainlib::Win(pane1) [$::Mainlib::Win(panew) add -weight 2]
    set ::Mainlib::Win(pane2) [$::Mainlib::Win(panew) add -weight 5]
    
    #set ::Mainlib::Win(bbox2) [ButtonBox $::Mainlib::Win(csmframe).bbox2 \
        #-spacing 0 \
    	#-padx 1 \
    	#-pady 1\
        #-orient vertical \
    	#-background #336699 \
    	#-homogeneous 1]
    
    ##
    ##  TREE WINDOW
    ##
	frame $::Mainlib::Win(pane1).tfm
	pack $::Mainlib::Win(pane1).tfm \
	    -expand 1 \
		-fill both

    scrollbar $::Mainlib::Win(pane1).tfm.xscroll \
        -command [list $::Mainlib::Win(pane1).tfm.tree xview] \
	-orient horizontal \
        -takefocus 0

    scrollbar $::Mainlib::Win(pane1).tfm.yscroll \
        -command [list $::Mainlib::Win(pane1).tfm.tree yview] \
	-takefocus 0

    

    set ::Mainlib::Win(tree) [Tree $::Mainlib::Win(pane1).tfm.tree \
	-width 650 \
	-deltay 22 \
        -dropenabled 1 \
    	-dragenabled 1 \
    	-dragevent 3 \
    	-opencmd   "::Mainlib::nodeOpen" \
    	-droptypes {
    	    TREE_NODE    {copy {} move {} link {}}
    	     LISTBOX_ITEM {copy {} move {} link {}}
    	} \
        -yscrollcommand [list $::Mainlib::Win(pane1).tfm.yscroll set] \
        -xscrollcommand [list $::Mainlib::Win(pane1).tfm.xscroll set]]
    
    $::Mainlib::Win(tree) bindText <ButtonPress-1>  "::Mainlib::select 1"
    $::Mainlib::Win(tree) bindImage <ButtonPress-1> "::Mainlib::select 1"
    $::Mainlib::Win(tree) bindText <Double-ButtonPress-1> "::Mainlib::select 2"
    $::Mainlib::Win(tree) bindImage <Double-ButtonPress-1> "::Mainlib::select 2"
    

    # we split pane 2 into a and b parts
    # if introspection is turned on in preferences
    if {$PgAcVar(pref,showintropane)} {
        frame $::Mainlib::Win(pane2).fm
        pack $::Mainlib::Win(pane2).fm \
            -expand 1 \
            -fill both
        set ::Mainlib::Win(pane2w) [PanedWindow $::Mainlib::Win(pane2).fm.pane \
            -side right \
            -weights available]
        pack $::Mainlib::Win(pane2).fm.pane \
            -expand 1 \
            -fill both
        set ::Mainlib::Win(pane2a) [$::Mainlib::Win(pane2w) add -weight 5]
        set ::Mainlib::Win(pane2b) [$::Mainlib::Win(pane2w) add -weight 2]
    } else {
        set ::Mainlib::Win(pane2a) $::Mainlib::Win(pane2)
    }

    # start of pane 2a, the tabelist of database objects
    frame $::Mainlib::Win(pane2a).lbfm
    pack $::Mainlib::Win(pane2a).lbfm \
        -expand 1 \
        -fill both

    scrollbar $::Mainlib::Win(pane2a).lbfm.xscroll \
        -command [list $::Mainlib::Win(pane2a).lbfm.list xview] \
	-orient horizontal \
        -takefocus 0

    scrollbar $::Mainlib::Win(pane2a).lbfm.yscroll \
        -command [list $::Mainlib::Win(pane2a).lbfm.list yview] \
	-takefocus 0

    set ::Mainlib::Win(mclist) [tablelist::tablelist \
        $::Mainlib::Win(pane2a).lbfm.list \
        -yscrollcommand [list $::Mainlib::Win(pane2a).lbfm.yscroll set] \
        -xscrollcommand [list $::Mainlib::Win(pane2a).lbfm.xscroll set] \
        -labelcommand tablelist::sortByColumn \
        -selectbackground #DDDDDD \
        -font $::PgAcVar(pref,font_normal) \
        -labelfont PGfont \
        -stretch all \
        -columns [list 0 "" left] \
        -selectforeground #708090
        ]

    set body [$::Mainlib::Win(mclist) bodypath]
    bind $body <Double-Button-1> [bind TablelistBody <Double-Button-1>]
    bind $body <Double-Button-1> +[list ::Mainlib::cmd_Open]

    # introspect
    bind $body <Button-1> [bind TablelistBody <Button-1>]
    bind $body <Button-1> +[list ::Mainlib::cmd_Introspect]

    menu $::Mainlib::Win(mclist).popup
    foreach PU {New Open Design Copy Rename Delete} {

        $::Mainlib::Win(mclist).popup add command \
            -label [intlmsg "$PU"] \
            -command ::Mainlib::cmd_$PU
    }

    bind $body <ButtonRelease-3> {
        tk_popup $::Mainlib::Win(mclist).popup %X %Y 0
    }

    # pane2b, SQL introspection window
    if {$PgAcVar(pref,showintropane)} {

        frame $::Mainlib::Win(pane2b).sqlfm
        pack $::Mainlib::Win(pane2b).sqlfm \
            -expand 1 \
            -fill both

        scrollbar $::Mainlib::Win(pane2b).sqlfm.xscroll \
            -command [list $::Mainlib::Win(pane2b).sqlfm.text xview] \
            -orient horizontal \
            -takefocus 0

        scrollbar $::Mainlib::Win(pane2b).sqlfm.yscroll \
            -command [list $::Mainlib::Win(pane2b).sqlfm.text yview] \
            -takefocus 0

        set ::Mainlib::Win(sqlintro) [text \
            $::Mainlib::Win(pane2b).sqlfm.text \
            -yscrollcommand [list $::Mainlib::Win(pane2b).sqlfm.yscroll set] \
            -xscrollcommand [list $::Mainlib::Win(pane2b).sqlfm.xscroll set] \
            -font $::PgAcVar(pref,font_fix)
            ]

        # introspect in SQL query builder
        bind $::Mainlib::Win(sqlintro) <Button-1> [list ::Mainlib::cmd_Introspect 1]

    } else {
        set ::Mainlib::Win(sqlintro) ""
    }

    set mainwin .
    # bindings for some common keyboard shortcuts
    bind $mainwin <Control-Key-q> {
        exit
    }

    # these commands also availabe from upper right icons and right-click
    bind $mainwin <Control-Key-n> {
        ::Mainlib::cmd_New
    }
    bind $mainwin <Control-Key-c> {
        ::Mainlib::cmd_Copy
    }
    bind $mainwin <Control-Key-r> {
        ::Mainlib::cmd_Rename
    }
    bind $mainwin <Control-Key-x> {
        ::Mainlib::cmd_Delete
    }
    bind $mainwin <Control-Key-d> {
        ::Mainlib::cmd_Design
    }
    bind $mainwin <Control-Key-o> {
        ::Mainlib::cmd_Open
    }


    set ::Mainlib::Win(hostlabel) [label $::Mainlib::Win(labelframe).lshost \
        -anchor w \
        -background white \
        -relief groove \
        -text localhost \
        -width 28]

    set ::Mainlib::Win(dblabel) [label $::Mainlib::Win(labelframe).lsdbname \
        -anchor w \
        -background white \
        -relief groove \
        -width 20]

    set ::Mainlib::Win(verlabel) [label $::Mainlib::Win(labelframe).lsversion \
	-anchor w \
        -background white \
	-relief groove \
        -width 15]

    set ::Mainlib::Win(statuslabel) [label $::Mainlib::Win(labelframe).lsstatus \
	-anchor w \
        -width 20]

    set ::Mainlib::Win(secure) [label $::Mainlib::Win(labelframe).secure \
	    -image ::icon::decrypted-22 \
	    -anchor w]

    # pane 1

    grid $::Mainlib::Win(tree) \
        -row 0 \
        -column 0 \
        -sticky news

    grid $::Mainlib::Win(pane1).tfm.xscroll \
        -row 1 \
        -column 0 \
        -sticky ew

    grid $::Mainlib::Win(pane1).tfm.yscroll \
        -row 0 \
        -column 1 \
        -sticky ns

    grid columnconfigure $::Mainlib::Win(pane1).tfm 0 \
        -weight 10
    grid rowconfigure $::Mainlib::Win(pane1).tfm 0 \
        -weight 10

    # pane 2a

    grid $::Mainlib::Win(mclist) \
        -row 0 \
        -column 0 \
        -rowspan 2 \
        -sticky news

    grid $::Mainlib::Win(pane2a).lbfm.xscroll \
        -row 2 \
        -column 0 \
        -sticky ew

    grid $::Mainlib::Win(pane2a).lbfm.yscroll \
        -row 1 \
        -column 1 \
        -sticky ns

    grid columnconfigure $::Mainlib::Win(pane2a).lbfm 0 \
        -weight 10
    grid rowconfigure $::Mainlib::Win(pane2a).lbfm 1 \
        -weight 10

    # pane 2b

    if {$PgAcVar(pref,showintropane)} {

        grid $::Mainlib::Win(sqlintro) \
            -row 0 \
            -column 0 \
            -rowspan 2 \
            -sticky news

        grid $::Mainlib::Win(pane2b).sqlfm.xscroll \
            -row 2 \
            -column 0 \
            -sticky ew

        grid $::Mainlib::Win(pane2b).sqlfm.yscroll \
            -row 1 \
            -column 1 \
            -sticky ns

        grid columnconfigure $::Mainlib::Win(pane2b).sqlfm 0 \
            -weight 10
        grid rowconfigure $::Mainlib::Win(pane2b).sqlfm 1 \
            -weight 10

    }

    # not pane 1 or pane 2

    pack $::Mainlib::Win(csmframe).pane \
        -expand 1 \
        -fill both

    pack $::Mainlib::Win(bbox1) $::Mainlib::Win(toolframe).sep \
        -fill y \
        -side left \
        -padx 4 \
        -pady 2 \
        -anchor c

    pack $::Mainlib::Win(bbox2) \
		-padx 4 \
		-pady 2 \
	    -side right

    pack $::Mainlib::Win(hostlabel) $::Mainlib::Win(dblabel) $::Mainlib::Win(verlabel) $::Mainlib::Win(statuslabel)\
        -side left \
        -padx 2
        
    pack $::Mainlib::Win(secure) \
        -side right \
        -padx 2

    pack $::Mainlib::Win(toolframe) \
        -fill x

    pack $::Mainlib::Win(csmframe) \
        -fill both \
    	-expand 1

    pack $::Mainlib::Win(labelframe) \
        -pady 2 \
        -side top \
        -fill x

    ::Mainlib::handleToolBar

    return $base

}; # end proc vTclWindow.pgaw:Main




proc vTclWindow.pgaw:CopyObject {base} {
global PgAcVar

    if {$base == ""} {
        set base .pgaw:CopyObject
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 400x100+294+262
    wm maxsize $base 1280 1024
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base [intlmsg "Copy"]

    frame $base.f \
        -borderwidth 10
    pack $base.f \
        -expand 1 \
        -fill both
    set base $base.f

    Label $base.lconn \
        -text [intlmsg "Connection"]
    ComboBox $base.cbconn \
        -textvariable PgAcVar(Copy_To_Connection) \
        -values $PgAcVar(Connections_List) \
        -editable false

    Label $base.lname \
        -text [intlmsg "Name"]
    Entry $base.ename \
        -textvariable PgAcVar(New_Object_Name)

    ButtonBox $base.bbox \
        -orient horizontal \
        -homogeneous 1 \
        -spacing 2
    $base.bbox add \
        -relief link \
        -image ::icon::editcopy-22 \
        -helptext [intlmsg "Copy"] \
        -command {

            # get the right destination connection
            set H [lindex [split $PgAcVar(Copy_To_Connection) ":"] 0]
            set P [lindex [split $PgAcVar(Copy_To_Connection) ":"] 1]
            set D [lindex [split $PgAcVar(Copy_To_Connection) ":"] 2]
            set hand [::Connections::getHandle $H $D $P]

            if {$PgAcVar(New_Object_Name)==""} {
                showError [intlmsg "You must give object a new name!"]
                return
            }

                if {[lsearch -exact [::Database::getObjectsList $PgAcVar(activetab) $hand] $PgAcVar(New_Object_Name)] > -1} {
                    showError [format [intlmsg "Object '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    # special check for tables since we want
                    # to copy all of the table data
                    if {$PgAcVar(activetab)=="Tables"} {
                        set sql [::$PgAcVar(activetab)::clone $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name) $CurrentDB 1]
                    } else {
                        set sql [::$PgAcVar(activetab)::clone $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name) $CurrentDB]
                    }
                    if {![sql_exec noquiet $sql $hand]} {
                        showError [format [intlmsg "Object '%s' could not be copied!"] $PgAcVar(New_Object_Name)]
                    }
                    Mainlib::cmd_$PgAcVar(activetab)
                    Window destroy .pgaw:CopyObject
                }
                catch {pg_result $pgres -clear}

        }

    $base.bbox add \
        -relief link \
        -image ::icon::exit-22 \
        -helptext [intlmsg "Cancel"] \
        -command {
            Window destroy .pgaw:CopyObject
        }

    grid $base.bbox \
        -row 0 \
        -rowspan 2 \
        -column 2 \
        -sticky e
    grid $base.lconn \
        -row 0 \
        -column 0 \
        -sticky e
    grid $base.cbconn \
        -row 0 \
        -column 1 \
        -sticky we
    grid $base.lname \
        -row 1 \
        -column 0 \
        -sticky e
    grid $base.ename \
        -row 1 \
        -column 1 \
        -sticky we

    grid columnconfigure $base 1 \
        -weight 10

}

proc vTclWindow.pgaw:RenameObject {base} {
global PgAcVar

    if {$base == ""} {
        set base .pgaw:RenameObject
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 400x100+294+262
    wm maxsize $base 1280 1024
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base [intlmsg "Rename"]

    frame $base.f \
        -borderwidth 10
    pack $base.f \
        -expand 1 \
        -fill both
    set base $base.f

    Label $base.loldname \
        -text [intlmsg "Old Name"]
    Entry $base.eoldname \
        -textvariable PgAcVar(Old_Object_Name) \
        -state disabled

    Label $base.lnewname \
        -text [intlmsg "New Name"]
    Entry $base.enewname \
        -textvariable PgAcVar(New_Object_Name)

    ButtonBox $base.bbox \
        -homogeneous 1 \
        -orient horizontal \
        -spacing 2
    $base.bbox add \
        -relief link \
        -image ::icon::move-22 \
        -helptext [intlmsg "Rename"] \
        -command {

            if {$PgAcVar(New_Object_Name)==""} {
                showError [intlmsg "You must give object a new name!"]

            } elseif {$PgAcVar(activetab)=="Tables"} {
                set sql "
                    ALTER TABLE $PgAcVar(Old_Object_Name)
                      RENAME TO $PgAcVar(New_Object_Name)"
                set retval [sql_exec noquiet $sql]
                ::Diagrams::tbl_rename $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name)
                if {$retval} {
                    set sql "
                        UPDATE pga_layout
                           SET tablename='$PgAcVar(New_Object_Name)'
                         WHERE tablename='$PgAcVar(Old_Object_Name)'"
                    sql_exec quiet $sql
                    ::Mainlib::cmd_Tables
                    Window destroy .pgaw:RenameObject
                }

            } elseif {$PgAcVar(activetab)=="Views"} {
                set sql "
                    ALTER TABLE $PgAcVar(Old_Object_Name)
                      RENAME TO $PgAcVar(New_Object_Name)"
                set retval [sql_exec noquiet $sql]
                ::Diagrams::tbl_rename $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name)
                if {$retval} {
                    set sql "
                        UPDATE pga_layout
                           SET tablename='$PgAcVar(New_Object_Name)'
                         WHERE tablename='$PgAcVar(Old_Object_Name)'"
                    sql_exec quiet $sql
                    ::Mainlib::cmd_Views
                    Window destroy .pgaw:RenameObject
                }

            } elseif {$PgAcVar(activetab)=="Functions"} {
                set sql [::Functions::clone $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name)]
                set retval [sql_exec noquiet $sql]
                if {$retval} {
                    set sql "DROP FUNCTION $PgAcVar(Old_Object_Name)"
                    sql_exec quiet $sql
                    ::Mainlib::cmd_Functions
                    Window destroy .pgaw:RenameObject
                }

            } elseif {$PgAcVar(activetab)=="Sequences"} {
                set sql [::Sequences::clone $PgAcVar(Old_Object_Name) $PgAcVar(New_Object_Name)]
                set retval [sql_exec noquiet $sql]
                if {$retval} {
                    set sql "DROP SEQUENCE $PgAcVar(Old_Object_Name)"
                    sql_exec quiet $sql
                    ::Mainlib::cmd_Sequences
                    Window destroy .pgaw:RenameObject
                }

            } elseif {$PgAcVar(activetab)=="Queries"} {
                set sql "
                    SELECT *
                      FROM pga_queries
                     WHERE queryname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_queries\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Query '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_queries
                           SET queryname='$PgAcVar(New_Object_Name)'
                         WHERE queryname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    set sql "
                        UPDATE pga_layout
                           SET tablename='$PgAcVar(New_Object_Name)'
                         WHERE tablename='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Queries
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Reports"} {
                set sql "
                    SELECT *
                      FROM pga_reports
                     WHERE reportname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_reports\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Report '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_reports
                           SET reportname='$PgAcVar(New_Object_Name)'
                         WHERE reportname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Reports
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Graphs"} {
                set sql "
                    SELECT *
                      FROM pga_graphs
                     WHERE graphname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_graphs\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Graph '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_graphs
                           SET graphname='$PgAcVar(New_Object_Name)'
                         WHERE graphname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Graphs
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Forms"} {
                set sql "
                    SELECT *
                      FROM pga_forms
                     WHERE formname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_forms\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Form '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_forms
                           SET formname='$PgAcVar(New_Object_Name)'
                         WHERE formname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Forms
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Scripts"} {
                set sql "
                    SELECT *
                      FROM pga_scripts
                     WHERE scriptname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_scripts\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Script '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_scripts
                           SET scriptname='$PgAcVar(New_Object_Name)'
                         WHERE scriptname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Scripts
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Diagrams"} {
                set sql "
                    SELECT *
                      FROM pga_diagrams
                     WHERE diagramname='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_diagrams\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Diagram '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_diagrams
                           SET diagramname='$PgAcVar(New_Object_Name)'
                         WHERE diagramname='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Diagrams
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}

            } elseif {$PgAcVar(activetab)=="Images"} {
                set sql "
                    SELECT *
                      FROM pga_images
                     WHERE imagename='$PgAcVar(New_Object_Name)'"
                set pgres [wpg_exec $CurrentDB $sql]
                if {$PgAcVar(pgsql,status)!="PGRES_TUPLES_OK"} {
                    showError "[intlmsg {Error retrieving from}] pga_images\n$PgAcVar(pgsql,errmsg)\n$PgAcVar(pgsql,status)"
                } elseif {[pg_result $pgres -numTuples]>0} {
                    showError [format [intlmsg "Image '%s' already exists!"] $PgAcVar(New_Object_Name)]
                } else {
                    set sql "
                        UPDATE pga_images
                           SET imagename='$PgAcVar(New_Object_Name)'
                         WHERE imagename='$PgAcVar(Old_Object_Name)'"
                    sql_exec noquiet $sql
                    ::Mainlib::cmd_Images
                    Window destroy .pgaw:RenameObject
                }
                catch {pg_result $pgres -clear}
            }
        }

    $base.bbox add \
        -relief link \
        -image ::icon::exit-22 \
        -helptext [intlmsg "Cancel"] \
        -command {
            Window destroy .pgaw:RenameObject
        }

    grid $base.bbox \
        -row 0 \
        -rowspan 2 \
        -column 2 \
        -sticky e
    grid $base.loldname \
        -row 0 \
        -column 0 \
        -sticky e
    grid $base.eoldname \
        -row 0 \
        -column 1 \
        -sticky we
    grid $base.lnewname \
        -row 1 \
        -column 0 \
        -sticky e
    grid $base.enewname \
        -row 1 \
        -column 1 \
        -sticky we

    grid columnconfigure $base 1 \
        -weight 10

}


proc vTclWindow.pgaw:GetParameter {base} {
	if {$base == ""} {
		set base .pgaw:GetParameter
	}
	if {[winfo exists $base]} {
		wm deiconify $base; return
	}
	toplevel $base -class Toplevel
	wm focusmodel $base passive
	set sw [winfo screenwidth .]
	set sh [winfo screenheight .]
	set x [expr ($sw - 297)/2]
	set y [expr ($sh - 98)/2]
	wm geometry $base 297x98+$x+$y
	wm maxsize $base 1280 1024
	wm minsize $base 1 1
	wm overrideredirect $base 0
	wm resizable $base 0 0
	wm deiconify $base
	wm title $base [intlmsg "Input parameter"]
	label $base.l1 \
		-anchor nw -borderwidth 1 \
		-justify left -relief sunken -textvariable PgAcVar(getqueryparam,msg) -wraplength 200 
	entry $base.e1 \
		-textvariable PgAcVar(getqueryparam,var) 
	bind $base.e1 <Key-KP_Enter> {
		set PgAcVar(getqueryparam,result) 1
destroy .pgaw:GetParameter
	}
	bind $base.e1 <Key-Return> {
		set PgAcVar(getqueryparam,result) 1
destroy .pgaw:GetParameter
	}
	button $base.bok \
		-borderwidth 1 -command {set PgAcVar(getqueryparam,result) 1
destroy .pgaw:GetParameter} -text Ok 
	button $base.bcanc \
		-borderwidth 1 -command {set PgAcVar(getqueryparam,result) 0
destroy .pgaw:GetParameter} -text [intlmsg Cancel]
	place $base.l1 \
		-x 10 -y 5 -width 201 -height 53 -anchor nw -bordermode ignore 
	place $base.e1 \
		-x 10 -y 65 -width 200 -height 24 -anchor nw -bordermode ignore 
	place $base.bok \
		-x 225 -y 5 -width 61 -height 26 -anchor nw -bordermode ignore 
	place $base.bcanc \
		-x 225 -y 35 -width 61 -height 26 -anchor nw -bordermode ignore 
}


proc vTclWindow.pgaw:SQLWindow {base} {
	if {$base == ""} {
		set base .pgaw:SQLWindow
	}
	if {[winfo exists $base]} {
		wm deiconify $base; return
	}
	toplevel $base -class Toplevel
	wm focusmodel $base passive
	wm geometry $base 551x408+192+169
	wm maxsize $base 1280 1024
	wm minsize $base 1 1
	wm overrideredirect $base 0
	wm resizable $base 1 1
	wm deiconify $base
	wm title $base [intlmsg "SQL window"]
	frame $base.f \
		-borderwidth 1 -height 392 -relief raised -width 396 
	scrollbar $base.f.01 \
	    -borderwidth 1 -command {.pgaw:SQLWindow.f.t xview} -orient horiz
	scrollbar $base.f.02 \
		-borderwidth 1 -command {.pgaw:SQLWindow.f.t yview} -orient vert
	text $base.f.t \
		-borderwidth 1 \
		-height 200 -width 200 -wrap word \
		-xscrollcommand {.pgaw:SQLWindow.f.01 set} \
		-yscrollcommand {.pgaw:SQLWindow.f.02 set} 
	button $base.b1 \
		-borderwidth 1 -command {.pgaw:SQLWindow.f.t delete 1.0 end} -text [intlmsg Clean]
	button $base.b2 \
		-borderwidth 1 -command {destroy .pgaw:SQLWindow} -text [intlmsg Close] 
	grid columnconf $base 0 -weight 1
	grid columnconf $base 1 -weight 1
	grid rowconf $base 0 -weight 1
	grid $base.f \
		-in .pgaw:SQLWindow -column 0 -row 0 -columnspan 2 -rowspan 1 
	grid columnconf $base.f 0 -weight 1
	grid rowconf $base.f 0 -weight 1
	grid $base.f.01 \
		-in .pgaw:SQLWindow.f -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
	grid $base.f.02 \
		-in .pgaw:SQLWindow.f -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
	grid $base.f.t \
		-in .pgaw:SQLWindow.f -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nsew
    grid $base.b1 \
        -in .pgaw:SQLWindow \
        -column 0 \
        -row 1 \
        -columnspan 1 \
        -rowspan 1
    grid $base.b2 \
        -in .pgaw:SQLWindow \
        -column 1 \
        -row 1 \
        -columnspan 1 \
        -rowspan 1
}


proc vTclWindow.pgaw:About {base} {

    if {$base == ""} {
        set base .pgaw:About
    }

    if {[winfo exists $base]} {
        wm deiconify $base
        return
    }

    toplevel $base \
        -bg white \
        -relief ridge \
        -bd 4

    set left [expr {[winfo screenwidth $base] / 2 - 150/2}]
    set top [expr {[winfo screenheight $base] / 2 - 250 / 2}]
    wm geometry $base "520x200+${left}+${top}"
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base [intlmsg "About"]

    image create photo $base.ilogo \
        -file [file join $::PgAcVar(PGACCESS_HOME) images logo.gif]
    Label $base.llogo \
        -image $base.ilogo \
        -relief flat \
        -bd 6 \
        -bg white

    grid $base.llogo \
        -row 0 \
        -column 0 \
        -sticky w \
        -rowspan 3

    set maintext [intlmsg "PgAccess
A Tcl/Tk interface to
PostgreSQL
by Constantin Teodorescu
v $::PgAcVar(VERSION)
You will always get the latest version at:
http://www.pgaccess.org
Suggestions at:
developers@pgaccess.org
"]
    Label $base.lmain \
        -text $maintext \
        -bg white

    grid $base.lmain \
        -row 0 \
        -sticky e \
        -column 1


    Label $base.lthnx \
        -text [intlmsg "Thanks to the following:"] \
        -bg white

    grid $base.lthnx \
        -row 1 \
        -column 1

    set ::PgAcVar(ABOUT_BYLINES) ""
    label $base.lbylines \
        -textvariable ::PgAcVar(ABOUT_BYLINES) \
        -fg #336699 \
        -bg white

    grid $base.lbylines \
        -row 2 \
        -column 1 \
        -sticky n

    set bylines [list]
    lappend bylines "Constantin Teodorescu - [intlmsg {original author}]"
    lappend bylines "Bartus Levente - [intlmsg {developer}]"
    lappend bylines "Brett Schwarz - [intlmsg {developer}]"
    lappend bylines "Chris Maj - [intlmsg {developer}]"
    lappend bylines "Iavor Raytchev - [intlmsg {infrastructure}]"
    lappend bylines "Adam Witney & Tony Grant - OSX"
    lappend bylines "Adam Leko - [intlmsg {splash screen}]"
    lappend bylines "Brett Green - graphs"
    lappend bylines "L.J. Bayuk - pgin.tcl"
    lappend bylines "Adrian Davis - ICONS"
    lappend bylines "Bryan Oakley - tkwizard"
    lappend bylines "Csaba Nemethi - Tablelist"
    lappend bylines "BWidgets contributors"
    lappend bylines "tcllib contributors"
    lappend bylines "F. Voloch - Barcode"
    lappend bylines "Robert Heller - StripPSComments"
    lappend bylines [intlmsg "All who translate intlmsg stuff!"]
    lappend bylines [intlmsg "Everyone who sends patches!"]
    lappend bylines [intlmsg "Our wonderful bug reporters!"]
    lappend bylines [intlmsg "INSERT YOUR NAME HERE"]

    set tymer 0
    foreach by $bylines {
        incr tymer
        set aftr [expr {$tymer*4000}]
        set line ""
        for {set i 0} {$i<[string length $by]} {incr i} {
            append line [string index $by $i]
            set aftr [expr {$aftr+75}]
            after $aftr [list set ::PgAcVar(ABOUT_BYLINES) "$line"]
        }
    }

}
