#----------------------------------------------------------
# env.tcl
#
#    Loading the environment variables
#
#----------------------------------------------------------
debug "\nLoading the enviroment variables:"

# list for the examined env variables
set var_list ""

# specifying the env variables that will be examined
lappend var_list "HOME" "Users home directory"
lappend var_list "PGLIB" "PostgreSQL interface library (libpgtcl)"

array set var_array $var_list

# parsing the specified env variables
foreach i [array names var_array] {
	if {[info exists env($i)]} {
		set PgAcVar($i) $env($i)
		debug "\t$var_array($i): $i = $PgAcVar($i)"
	}
}

# cleaning up
unset var_list
unset var_array
