# adapted from http://wiki.tcl.tk/9353

source icons.tcl
#set orig [lindex $argv end]
#set orig "../images/pink_elephant.gif"
set orig "../images/pink_elephant.png"
set icoFile "../images/tclkit.ico"
catch {[exec rm $icoFile]}

pack [label .l -textvariable state]

exec convert $orig $orig.gif
image create photo temp48 -file $orig.gif
::ico::writeIcon $icoFile ICO 0 8 temp48
file delete $orig.gif

set pos -1
foreach s {48 32 16} {
    set name [format "temp%s" $s]
    set geom [format %dx%d $s $s]
    set state "$geom @ 256"
    update idle
    exec convert -antialias -scale $geom -colors 256 $orig $name.gif
    image create photo $name -file $name.gif
    ::ico::writeIcon $icoFile ICO [incr pos] 8 $name
    set state "$geom @ 16"
    update idle
    exec convert -antialias -scale $geom -colors 16 $orig r$name.gif
    image create photo r$name -file r$name.gif
    ::ico::writeIcon $icoFile ICO [incr pos] 4 r$name
    file delete $name.gif r$name.gif
}

set state "DONE - Icon file is $icoFile"
for {set i 0} {$i<6} {incr i} {
    pack [label .lstat$i -text [lindex [::ico::IconStats $icoFile ICO] $i]]
    pack [label .limg$i -background blue -image [::ico::getIconImage $icoFile ICO $i]]
}
pack [button .b -text "EXIT" -command exit]

